-------------------------------------------------------------------

     ==========================================================
     Geant4 - an Object-Oriented Toolkit for Physics Simulation
     ==========================================================

          History file for hadronic/models/de_excitation
          ----------------------------------------------

This file should be used to summarize modifications introduced in the
code and to keep track of all tags.

     ---------------------------------------------------------------
     * Please list in reverse chronological order (last date on top)
     ---------------------------------------------------------------

02 November 2021 Vladimir Ivanchenko  (hadr-deex-V10-07-08)
- G4PhotonEvaporation - changed logic de-excitation from levels, which
    has no data on transitions: instead of transition to closest level 
    continues transition is performed. This should fix #2434 reducing
    production of fragments with high excitation and high angular
    momentum
- G4DeexPrecoParameters - fixed propagation of verbosity level between
    components of the de-excitation module 

30 September 2021 Vladimir Ivanchenko  (hadr-deex-V10-07-07)
- G4PhotonEvaporation - fixed Coverity warning

04 August 2021 Alberto Ribon  (hadr-deex-V10-07-06)
- G4DeexPrecoParameters, G4ExcitationHandler :
  migrated to the new version of G4PhysicsModelCatalog
- G4EvaporationChannel, G4UnstableFragmentBreakUp,
  G4PhotonEvaporation, G4NeutronRadCapture,
  G4GEMChannel, G4GEMChannelVI, G4FermiBreakUpVI, G4StatMF,
  G4CompetitiveFission, G4WilsonAblationModel :
  set creator model ID for secondaries, using the new version of
  G4PhysicsModelCatalog

01 July 2021 Vladimir Ivanchenko  (hadr-deex-V10-07-05)
- Removed obsolete and not used  model G4ParaFissionModel, this
  fixes also circular dependences inside the de-excitation module

16 April 2021 Ben Morgan (hadr-deex-V10-07-04)
- Migrate build to modular CMake API

15 April 2021 Vladimir Ivanchenko  (hadr-deex-V10-07-03)
- G4DeexPrecoParameters - fixed problem #2350

13 April 2021 Alberto Ribon  (hadr-deex-V10-07-02)
- GNUmakefile, sources.cmake : removed the subdirectories
  hadronic/models/management and hadronic/models/util
  (that have been now deleted, with their classes moved to
   hadronic/util and hadronic/management).

07 March 2021 Vladimir Ivanchenko  (hadr-deex-V10-07-01)
- G4PolarizationTransition - J.Detwiler fixed sampling of angular
  correlations (problem #2344)

18 February 2021 Alberto Ribon  (hadr-deex-V10-07-00)
- G4DeexPrecoParameters - changed half-life time threshold for isomer
  production from 1 microsecond to 1 nanosecond.
  The goal is to avoid unphysical missing energy cases as reported by
  NA61/SHINE Collaboration. The open question is whether the CPU
  overhead is negligible for the LHC experiments.

12 August 2020 Vladimir Ivanchenko  (hadr-deex-V10-06-07)
- G4NuclearLevelData - use Zmax for initialisation before the run

28 July 2020 Vladimir Ivanchenko  (hadr-deex-V10-06-06)
- G4ExcitationHandler - verbose level is defined by G4HadronicParameters
    class or by the hardcoded local verbose level defined only for
    debugging
- G4DeexPrecoParameters - verbose level is defined  by G4HadronicParameters
    class or by the local verbose level
- G4DeexParametersMessenger - removed obsolete UI command

24 July 2020 Vladimir Ivanchenko  (hadr-deex-V10-06-05)
- G4NuclearLevelData - reduced usage of mutex locks; read all level data
    begin of run
- G4ExcitationHandler - use Zmax+1 instead of Zmax for nuclear level
    initialisation

13 July 2020 Vladimir Ivanchenko  (hadr-deex-V10-06-04)
- G4NuclearLevelData - more safe initialisation of data in MT mode, use mutex
    locks only within each method, whithout calls to other methods
- G4ExcitationHandler - call to G4NuclearLevelData to initilise data for
    levels for all elements possibly involved in the geometry

12 May 2020   Alberto Ribon       (hadr-deex-V10-06-03)
- G4DeexPrecoParameters : in the method Dump(), check the global verbosity
  level of hadronics (if zero, do not print anything).

05 May 2020   Gunter Folger       (hadr-deex-V10-06-02)
- Fix for clang10: mark class final, as dtor is final.
   affected: fermi_breakup/include/G4FermiBreakUpVI.hh
             gem_evaporation/include/G4GEMChannelVI.hh
	     gem_evaporation/include/G4GEMProbabilityVI.hh

05 March 2020 Vladimir Ivanchenko (hadr-deex-V10-06-01)
- G4DeexPrecoParameters - set default time limit 1 microsecond and
    enable isomere production (related to problem #2226)

13 February 2020 Vladimir Ivanchenko (hadr-deex-V10-06-00)
- G4PhotonEvaporation, G4DeexPrecoParameters, G4DeexParametersMessager
    added extra flag - IsomerProduction, if it is enabled photon
    evaporation samples time of gamma transition; added C++ interface
    and UI command allowing set this flag; radioactive decay constructor
    should enable this parameter; fix of problem #2226

25 November 2019 Vladimir Ivanchenko (hadr-deex-V10-05-21)
- G4PhotonEvaporation - fixed Coverity problem

16 November 2019 Vladimir Ivanchenko (hadr-deex-V10-05-20)
- G4PhotonEvaporation - access G4NuclearPolarizationStore only
    if correlated gamma decay is enabled

11 November 2019 Vladimir Ivanchenko (hadr-deex-V10-05-19)
- G4CompetitiveFission, G4FissionBarrier, G4FissionParameters - added
    numerical protections; cleanup C++11 keywords; move headers to
    source code

05 November 2019 Vladimir Ivanchenko (hadr-deex-V10-05-18)
- G4NuclearLevelData, G4LevelManager, G4GEMChannel, G4GEMProbability,
  G4GEMProbabilityVI, G4EvaporationChannel, G4EvaporationProbability
    use consistently pairing correction from G4NuclearLevelData and
    verbosity level for debigging
- G4FermiBreakUpVI - use consistently verbosity from de-excitation
    module, simplified decay kinematics
- G4VEmissionProbability, G4Evaporation, G4UnstableFragmentBreakUp
    consistently used decay channels in all components of the
    de-excitation module
- G4ExcitationHandler - fixed problem seen in medical test of
    fragmentation - provide full de-excitation of excited light
    fragments
- G4PhotonEvaporation - fixed gamma de-excitation when initial
    excitation energy is between ground and 1st levels

19 October 2019 Vladimir Ivanchenko (hadr-deex-V10-05-17)
- G4ExcitationHandler, G4Evaporation - attempt to reduce CPU

16 October 2019 Vladimir Ivanchenko (hadr-deex-V10-05-16)
- G4ExcitationHandler, G4Evaporation - improved debug printout
- G4UnstableFragmentBreakUp - allowed only residual fragments, which
    are present in the nuclear level DB; those fragments which are not
    in the DB are forced to decay on fragments from the DB;
    improved debug printout

02 October 2019 Vladimir Ivanchenko (hadr-deex-V10-05-15)
- G4ExcitationHandler - removed warning on high excitation
- G4NuclearLevelData - added new public interface to enable
    upload of nuclear level data before 1st event with the signature:
    UploadNuclearLevelData(G4int maxZ)
- G4LevelReader - small reduction of memory churn
- G4DeexPrecoParameters - added two new parameters
- G4DeexParametersMessenger - added UI command
- G4VEmissionProbability - implemented option to force a residual
    nucleus to be at one of known discrete levels
- G4FermiFragmentsPoolVI - removed unphysical fragments and corresponding
    data structures
- G4FermiFragment - removed unused boolean members
- G4FermiBreakUpVI - clean internal data after decay loop and not before

18 September 2019 Vladimir Ivanchenko (hadr-deex-V10-05-14)
- G4ExcitationHandler - removed second photon evaporation loop,
    because since long all gamma decay are already happens in the
    1st loop; use more C++11 constructions
- G4FermiFragmentsPoolVI - implement new method HasChannels(..)
- G4FermiBreakUpVI - use new HasChannels(..) inside IsAPplicable(..)
- G4Evaporation - make coherent use of IsApplicable(..)
    from FermiBreakUp and force simplified decay of exotic fragments
    with G4UnstableFragmentBreakUp
- G4UnstableFragmentBreakUp - change logic allowing decay of an
    exotic fragment (fragment is not known in gamma level DB) and
    never release it

11 September 2019 Vladimir Ivanchenko (hadr-deex-V10-05-13)
- G4ExcitationHandler - added limit on number of warnings on high
    excitation of input fragment; fixed Coverity warnings

14 August 2019 Vladimir Ivanchenko (hadr-deex-V10-05-12)
- G4ExcitationHandler - added check on upper limit of excitations
- G4DeexPrecoParameters - added upper limit 30 MeV on excitation
    per nucleon

08 August 2019 Vladimir Ivanchenko (hadr-deex-V10-05-11)
- G4ExcitationHandler - fixed initialisation sequence

23 July 2019 Vladimir Ivanchenko (hadr-deex-V10-05-10)
- G4ExcitationHandler, G4Evaporation - optimise initialisation reducing
    memory churn
- G4VEvaporationChannel, G4VEmissionProbability, G4EvaporationChannel,
  G4EvaporationProbability - clean-up private and protected members and
    methods
- G4AlphaEvaporationChannel, G4AlphaEvaporationProbability,
  G4DeuteronEvaporationChannel, G4DeuteronEvaporationProbability,
  G4He3EvaporationChannel, G4He3EvaporationProbability,
  G4NeutronEvaporationChannel, G4NeutronEvaporationProbability,
  G4ProtonEvaporationChannel, G4ProtonEvaporationProbability,
  G4TritonEvaporationChannel, G4TritonEvaporationProbability - clean-up
- G4GEMChannelVI, G4GEMProbabilityVI - new GEM model


17 July 2019 Vladimir Ivanchenko (hadr-deex-V10-05-09)
- G4VEvaporationChannel, G4VEmissionProbability, G4VEvaporationFactory,
  G4EvaporationGEMFactory, G4EvaporationGEMFactoryVI, G4GEMChannelVI,
  G4EvaporationDefaultGEMFactory, G4EvaporationFactory,
  G4EvaporationChannel, G4EvaporationProbability,
  G4EvaporationProbabilityVI - a modification of internal interfaces
    allowing reuse code established for evaporation in the new GEM
    evaporation model, use more C++11 patterns
- G4FermiFragmentsPoolVI, G4NuclearLevelData - reduce number of locks
    at initialisation, use more C++11 patterns

10 July 2019 Vladimir Ivanchenko (hadr-deex-V10-05-08)
- G4EvaporationChannel, G4EvaporationProbability,
  G4NeutronEvaporationProbability, G4VEmissionProbability,
  G4VEvaporationChannel - preparation for development of new GEM model,
    for evaporation improved selection of final excitation level for
    residual fragment
- G4LevelReader - attempt to reduce memory churn at initialisation

04 June 2019 Vladimir Ivanchenko (hadr-deex-V10-05-07)
- G4ExcitationHandler - removed debug cout

30 May 2019 Vladimir Ivanchenko (hadr-deex-V10-05-06)
- G4Evaporation, G4ExcitationHandler, G4LevelReader,
  G4VEmissionProbability, G4GammaTransition, G4PhotonEvaporation,
  G4PolarizationTransition - changed scheme of verbosity, 0- silence,
  1- dump of parameters at initialisation, 2- debugg printout,
  3- very detailed debug printout (Bugzilla #2098)
- G4CoulombBarrier - use G4NuclearRadii utility to copute nuclear radius

13 May 2019 Gabriele Cosmo (hadr-deex-V10-05-05)
- Replaced deprecated std::binary_function calls with lambdas in
  G4StatMFMicroCanonical and G4StatMFChannel.
  Courtesy of S.Losilla, from GitHub PR#8.

06 May 2019 Vladimir Ivanchenko (hadr-deex-V10-05-04)
- G4VEmissionProbability - use simple rejection
- G4FermiFragment - fixed Coulomb barrier correction computation

30 April 2019 Vladimir Ivanchenko (hadr-deex-V10-05-03)
- G4EvaporationChannel, G4EvaporationProbability,
  G4FermiDecayProbability, G4VEmissionProbability -
    simplified algorithm to sample kinetic energy of a fragment;
    minor code clean-up, removed commented lines

18 March 2019 Vladimir Ivanchenko (hadr-deex-V10-05-02)
- G4PhotonEvaporation - for nuclear levels without decay modes defined
    perform decay not to the ground state but to the nearest level
    (problem #2123)
- G4LevelManager, G4NucLevel - fixed debug and warning printouts

12 March 2019 Vladimir Ivanchenko (hadr-deex-V10-05-01)
- G4PhotonEvaporation - fixed decay from nuclear level, which has no
    decay channels defined (problem #2123)

28 January 2019 Vladimir Ivanchenko (hadr-deex-V10-05-00)
- G4LevelReader - fixed typo (problem #2124)

05 December 2018 Gabriele Cosmo (hadr-deex-V10-04-19)
- G4ExcitationHandler: added protection to verbosity printouts in
  SetDeexChannelsType() and Initialise() methods.

20 November 2018 Vladimir Ivanchenko (hadr-deex-V10-04-18)
- G4LevelReader - (L.Desorgher) fAlphaMax is changed from
    1.e+6 to 1.e+15 (needed for correct IC probability of some
    isotopes)

13 November 2018 Vladimir Ivanchenko (hadr-deex-V10-04-17)
- G4PhotonEvaporation - improved debug printout

09 November 2018 Gabriele Cosmo (hadr-deex-V10-04-16)
- Fixed few printout typos.

05 November 2018 Vladimir Ivanchenko (hadr-deex-V10-04-15)
- G4UnstableFragmentBreakUp - fixed Coverity warning

26 October 2018 Vladimir Ivanchenko (hadr-deex-V10-04-14)
- G4CompetitiveFission, G4FissionLevelDensityParameter,
  G4FissionLevelDensityParameterINCLXX, G4FissionProbability -
    tuned fission parameters
- G4DeexPrecoParameters -  default level density parameter 0.075
- G4LevelManager - added a member and Get method for shell correction

22 October 2018 Vladimir Ivanchenko (hadr-deex-V10-04-13)
22 October 2018 Vladimir Ivanchenko (hadr-deex-V10-04-12)
- Fixed GNUmakefile and source.cmake
- G4NuclearLevelData - fixed new methods and use data from recent
    gamma levels

21 October 2018 Vladimir Ivanchenko (hadr-deex-V10-04-11)
19 October 2018 Vladimir Ivanchenko (hadr-deex-V10-04-09)
- G4DeexPrecoParameters - default level density parameter is reduced from
    0.1 to 0.08
- removed circular dependence between de-excitation sub-packages
  introduced in previous tag

18 October 2018 Vladimir Ivanchenko (hadr-deex-V10-04-08)
- G4LevelManager, G4NuclearLevelData, G4LevelReader - added initialisation
    of level density and pairing correction per isotope, added
    possibility to choose between two parameterisations of level
    density
- G4EvaporationProbability, G4CompetitiveFission, G4VEmissionProbability,
  G4PhotonEvaporation - coherent use of the same parameterisation of
     level density and pairing correction between all models
- G4FissionLevelDensityParameter, G4FissionLevelDensityParameterINCLXX,
  G4EvaporationLevelDensityParameter, G4CoulombBarrier,
  G4PairingCorrection - clean up according G4NuclearLevelData
- G4DeexPrecoParameters - default level density parameter is reduced from
    0.1 to 0.09

08 October 2018 Vladimir Ivanchenko (hadr-deex-V10-04-07)
- G4DeexPrecoParameters - added extra parameter for the FBU model
- G4EvaporationProbability - added option 4 for de-excitation
- G4LevelReader - change fatal exception by warning for problematic
    level index
- G4FermiFragmentsPoolVI - extended number of FBU fragments from
    399 to 991 and corresponding number of reaction channels

19 September 2018 Vladimir Ivanchenko (hadr-deex-V10-04-06)
- G4DeexPrecoParameters - set default deexcitation "evaporation+GEM"

24 August 2018 Vladimir Ivanchenko (hadr-deex-V10-04-05)
- G4LevelReader - attempt to fix problems #1986 and #2076 by
    change of hadling of internal conversion data

06 August 2018 Alberto Ribon (hadr-deex-V10-04-04)
- G4NeutronRadCapture : replaced the explicit high-energy limit of
  hadronic physics with the one from G4HadronicParameters .
- Changed the GNUmakefile to allow the new dependency on
  processes/hadronic/management/include/, where the class
  G4HadronicParameters is defined.

06 July 2018 Vladimir Ivanchenko (hadr-deex-V10-04-03)
- G4FermiPhaseSpaceDecay - moved long method from inline to source;
    added a protection for low mass of initial state

26 February 2018 Vladimir Ivanchenko (hadr-deex-V10-04-02)
26 February 2018 Vladimir Ivanchenko (hadr-deex-V10-04-01)
- G4ChatterjeeCrossSection, G4KalbachCrossSection - moved
    implementation to source
- G4VEmissionProbability, G4EvaporationProbability - fixed integration
    of probabilities for neutron emission for OPT=1,2
- G4DeexPrecoParameters - fixed checks on parameter values

19 December 2017 Gabriele Cosmo (hadr-deex-V10-04-00)
- Fixed self-consistency in G4ChatterjeeCrossSection header (missing #include).
  Fixed #ifdef guard in G4StatMFMacroBiNucleon header.
  Thanks to Raphael Isemann for reporting these.

03 November 2017 Vladimir Ivanchenko (hadr-deex-V10-03-51)
- G4DeexPrecoParameters - fixed printout of parameters

31 October 2017 Vladimir Ivanchenko (hadr-deex-V10-03-50)
- G4NeutronRadCapture, G4StatMFChannel, G4StatMFFragment,
  G4GEMChannel, G4CompetitiveFission, G4FermiPhaseSpaceDecay
    - used G4RandomDirection() for better CPU performance

19 October 2017 Vladimir Ivanchenko (hadr-deex-V10-03-49)
- G4DeexPrecoParameters, G4DeexParametersMessenger - added UI commands
    for configuration of de-excitation module and radioactive decay
- G4PhotonEvaporation, G4PhotonEvaporation - use new parameters to
    enable/disable correlated gamma

13 October 2017 Vladimir Ivanchenko (hadr-deex-V10-03-48)
- G4NuclearLevelData, G4NucLevel, G4LevelManager added possibility
    to print nuclear level information into output stream,
    interface cleanup, fixed reading user data file
- G4PhotonEvaporation, G4GEMChannelVI - use updated interface

21 August 2017 Vladimir Ivanchenko (hadr-deex-V10-03-47)
- G4NuclearLevelData - fully thread safe singleton

18 August 2017 Vladimir Ivanchenko (hadr-deex-V10-03-46)
- G4NuclearLevelData - hold and have access method to
    G4PairingCorrection and G4ShellCorrection classes;
    more safe MT initialisation of the Instance
- G4PairingCorrection, G4ShellCorrection - are not singletones anymore
- G4EvaporationChannel, G4FissionProbability, G4CompetitiveFission,
  G4FissionBarrier, G4GEMChannel, G4GEMChannelVI, G4GEMProbability,
  G4VEmissionProbability - changed access to G4PairingCorrection and
    G4ShellCorrection
- G4LevelReader - added extra G4Exception in file reading method

14 August 2017 Vladimir Ivanchenko (hadr-deex-V10-03-45)
- G4PolarisationTransition - make protection from previous tag
    according Jason Detwiler prescription

10 August 2017 Vladimir Ivanchenko (hadr-deex-V10-03-44)
- G4PolarisationTransition - added protections inside method
    GenerateGammaPhi(..) to avoid read outside vector;
    reduce sampling loop from 1000 to 100

07 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-43)
- G4DeexPrecoParameters - restore Get/SetInternalConversionFlag,
    true by default
- G4PhotonEvaporation - use flag for internal conversion,
    for radioactive decay do not sample transition if no transition
    information is available

04 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-42)
- G4PhotonEvaporation, G4GammaTransition, G4PolarizationTransition -
    improved debug printout, cleanup creation and deletion of
    G4NuclearPolarization objects

03 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-41)
- G4DeexPrecoParameters - added fDummy variant of de-excitation when
    excitation energy transformed to kinetic energy of a fragment
    and no secondaries are produced; added also SetPrecoDummy(..)
    method, which disable both precompound and de-excitation sampling
- G4ExcitationHandler - implement fDummy variant of de-excitation
- G4PhotonEvaporation - added handling of nuclear polarization for
    simulation of correlated gamma emission; for BreakUpChain(..)
    this is working for all consumer code; for EmittedFragmnet(..)
    interface - only if radioactive decay flag is ON; fixed data race
- G4PolarizationTransition - added new public interface
    SampleGammaTransition(..), which replaced 4 old public interfaces,
    code become more clear, sampling cosTheta and phi now performed
    by private methods
- G4GammaTransition - use this new SampleGammaTransition(..) method

19 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-40)
- G4WilsonAblationModel - C. Mancini Terracciano fixed crash at
    initialisation

16 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-39)
- G4DeexPrecoParameters - disable parameter change in G4_Idle state,
    only G4_PreInit is allowed
- G4ExcitationHandler - improved debug cout

15 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-38)
- G4DeexPrecoParameters - removed compilation warning of previous tag
- G4ExcitationHandler - added protection from incomplete
    initialisation when external evaporation instance is defined;
    removed debug cout

14 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-37)
- G4GammaTransition - more accurate protection for 2J > 6
- G4PhotonEvaporation, G4ExcitationHandler - extended local debug printout
- G4PolarizationTransition - use G4double, and std::sqrt
- G4DeexPrecoParameters - disable correlated gamma

13 June 2017 Alberto Ribon (hadr-deex-V10-03-36)
- G4PolarizationTransition : applied Jason Detwiler's fix to avoid integer
    overflow in the argument of sqrt(), and caching to speed up the
    calculations.
- G4GammaTransition : temporary workaround to avoid very long computations,
    by skipping polarization if initial state has angular momentum 2J > 6 .

13 June 2017 Vladimir Ivanchenko (hadr-deex-V10-03-35)
- G4GammaTransition - added a protection - do not sample nuclear
    polarization if initial state has momentum 2J > 12

1 June 2017 Dennis Wright (hadr-deex-V10-03-34)
- G4PolarizationTransition::GenerateGammaCosTheta: add Jason Detwiler's
    warning of zero coefficient

23 May 2017 Dennis Wright (hadr-deex-V10-03-33)
- G4PolarizationTransition::GenerateGammaCosTheta and
  G4PolarizationTransition::GenerateGammaPhi:  add warning when polarization
    entries are empty and return isotropic random in that case.  Fixes
    somewhat rare crash.

13 May 2017 Vladimir Ivanchenko (hadr-deex-V10-03-32)
- G4ExcitationHandler, G4NeutronRadCapture - propagate index of
    e- internal conversion to base class G4HadronicProcess

10 May 2017 Vladimir Ivanchenko (hadr-deex-V10-03-31)
- G4ExcitationHandler, G4DeexPrecoParameters - define index of
    e- internal conversion and propagate it to reaction products

28 April 2017 Vladimir Ivanchenko (hadr-deex-V10-03-30)
- G4LevelReader - by default issue G4Exception only for Z<6,
- G4LevelReader, G4LevelManager, G4NucLevel,  G4PhotonEvaporation
    use G4double for energy and life time (fix problem #1964)
- G4FermiFragmentsPoolVI, G4FemiBreakUpVI - fixed selection of decay
    chains for unphysical fragments, which happens when used by INCL++

27 April 2017 Vladimir Ivanchenko (hadr-deex-V10-03-29)
- G4LevelReader - by default issue G4Exception only for Z<9

08 April 2017 Vladimir Ivanchenko (hadr-deex-V10-03-28)
- G4PhotonEvaporation - fixed second part of the bug #1950
    always have gamma transition to the discrete level (if there is
    no levels - to the ground state)
- G4DeexPrecoParameters - set default MaxLifeTime = 1000 second
    (was 0.1 second)

05 April 2017 Vladimir Ivanchenko (hadr-deex-V10-03-27)
- G4LevelReader,  G4NuclearLevelData - removed code for reading of old
    data structure
- G4LevelReader - fixed fill of mpRatio parameter of a transition (was
    always zero before)

04 April 2017 Vladimir Ivanchenko (hadr-deex-V10-03-26)
- G4DeexPrecoParameters - disable possibility to read old data; make
    FatalException soon if the first file in the dataset cannot be red

04 April 2017 Vladimir Ivanchenko (hadr-deex-V10-03-24)
- G4LevelReader - read update data structure where "correlated_gamma"
    directory is
- G4LevelManager - removed obsolete method

20 March 2017 Vladimir Ivanchenko (hadr-deex-V10-03-23)
- G4LevelReader - fixed bug #1942 (FatalException if data file is
    not opened)
- G4PhotonEvaporation - fixed bug #1950 (perform transition to
    the ground state of an isotope if the floating level has zero
    excitation energy)

17 March 2017 Vladimir Ivanchenko (hadr-deex-V10-03-22)
- G4VEmissionProbability - added private method for general treatment
    of PDF functions
- G4EvaporationProbability, G4CompetitiveFission, G4CompetitiveFission,
  G4GEMProbability - changes are implemented according to base class
    modifications
- G4EvaporationChannel - make choice of minimal evaporation energy
    Z-dependent

07 March 2017 Vladimir Ivanchenko (hadr-deex-V10-03-21)
07 March 2017 Vladimir Ivanchenko (hadr-deex-V10-03-19)
- G4NuclearLevelData - synkronise the list of isotopes with the
    current set of data files - extra rare isotopes are allowed;
    Z max is extended from 102 to 117
- G4LevelReader - always create G4LevelManager for stable isotopes
    including light stable p, d, t, He3, He4
- G4LevelManager - removed obsolete method
- G4FermiFragmentsPoolVI - improved handling of internal data structure,
- G4ExcitationHandler, fermi_breakup, photon_evaporation sub-directories
    removed obsolete FermiBreakUp model and corresponding classes

02 March 2017 Vladimir Ivanchenko (hadr-deex-V10-03-18)
- G4LevelReader, G4FermiFragmentsPoolVI - fixed Coverity static
    analysis warnings

27 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-17)
- G4LevelReader, G4LevelManager, G4PhotonEvaporation - for stable states
    (ground state isotopes) life time is set to "-1", change all checks
    accordingly
- G4DeexPrecoParameters - default time limit 0.1s (if radioactive
    decay is enabled this time is set to the limit of the
    G4NuclideTable), this allows do not create extra isomeres
    if radioactive decay is not included in the physics list

21 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-15)
- G4LevelReader - in the case of broken file structure or absence of
    a file G4Exception will be issued

16 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-14)
- G4GammaTransition - added control on printout for all G4cout; removed
    thread unsafe check

15 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-13)
- G4GammaTransition - added control on printout
- G4LevelManager - fixed unpacking of spin

14 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-12)
  Fix no-reproducibility due to precision lost in Lorentz transformations
- G4ExcitationHandler, G4PhotonEvaporation - use floating level number
- G4GammaTransition - use a new method of G4Fragment::SetExcitationEnergy()
    which allows to keep excitation energy exact as in the database to
    avoid rare non-reproducibility; added SetVerbose method
- G4PolarizationTransition - added SetVerbose method; protect from
    extra verbosity

13 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-11)
  Fixed U235[0.076] problem:
- G4DeexPrecoParameters - min excitation energy is set to 10 eV (was 100 eV)
- G4LevelReader - if value of alpha (relative probability of the internal
    conversion) is 10^10, then assume that internal conversion will go via
    outer levels and gamma emission has zero probability, internal
    conversion is forced intdependently on other flags

08 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-10)
08 February 2017 Vladimir Ivanchenko (hadr-deex-V10-03-08)
- G4GammaTransition::SampleDirection - D.Wright fixed multipolarity
    after changing multipolarity Nx by 1 in the new dataset

27 January 2017 Vladimir Ivanchenko (hadr-deex-V10-03-07)
- G4GammaTransition, G4PhotonEvaporation, G4NuclLevel - minor cleanup
- G4DeexPrecoParameters - by default used uniform angular distribution
    in CM sytem of precompound decay

18 January 2017 Vladimir Ivanchenko (hadr-deex-V10-03-06)
- G4GammaTransition::SampleDirection - return back sampling in the case, when
    initial state has angular moment but its polarisation is random
- G4PhotonEvaporation - added internal conversion even if the data are not
    stored

11 January 2017  Dennis Wright (hadr-deex-V10-03-05)
- G4PolarizationTransition::SetGammaTransitionData: replace fTwoJ1 and fTwoJ2
  with their absolute values to avoid crash
- G4GammaTransition::SampleDirection: remove return; from (!np) block,
  otherwise only zero polarization is returned.
  Also remove line
    fPolTrans.UpdatePolarizationToFinalState(fDirection.z(), fDirection.phi(), nuc);
  in order to comply with instructions in G4PolarizationTransition.hh (call order)
  and to properly initialize the nuclear polarization.

 9 January 2017  Dennis Wright (hadr-deex-V10-03-04)
- G4NucLevel::TransitionType: use % operator to correctly strip off
  leading digit
- G4LevelReader::LevelManager: added comments to describe some variables
- G4PolarizationTransition::UpdatePolarizationToFinalState: add comment
  showing where zero-value entries are trimmed off

19 December 2016 Vladimir Ivanchenko (hadr-deex-V10-03-03)
- G4LevelReader - fixed Ra228 problem - read all levels from
    a data file

16 December 2016 Vladimir Ivanchenko (hadr-deex-V10-03-02)
- G4PolarizationTransition - J.Detwiler has fixed computation
    of multipolarity

16 December 2016 Vladimir Ivanchenko (hadr-deex-V10-03-01)
- G4DeexPrecoParameters - change default time limit from 0.01 s to
    1 microsecond
- G4PhotonEvaporation, G4GammaTransition - improved sampling
    and kinematics for internal conversion
- G4PolarizationTransition - J.Detwiler has fixed computation
    of polarisation

14 December 2016 Vladimir Ivanchenko (hadr-deex-V10-03-00)
- G4LevelManager, G4NuclLevel, G4LevelReader - reduce memory for
    description of a level: each two integer parameters are packed
    into one integer values; use only one set of probabilities of
    transition independently on use-case (HEP or radioactive decay);
    fill internal conversion coefficients into the data structure only
    if a flag SetStoreAllLevels() is set to true. In the last case,
    more memory required per isotope (~8 times)
- G4DeexPrecoParameters - extended Dump() printout; make new
    data structure default
- G4ExcitationHandler - moved Dump() printout in Initialise()
    method, print info if evaporation channels are changed; added
    local data member to control verbosity level
- G4VEvaporation - added extra const access method
- G4Evaporation - added data member to control verbosity level
- G4GammaTransition - in the case, when internal conversion data
    are not filled but in sampling e- emission is selected, sample e-
    with kinetic energy corresponding to transition between nuclear
    levels ignoring atomic effects

01 December 2016 Vladimir Ivanchenko (hadr-deex-V10-02-69)
- G4KalbachCrossSection, G4NuclearLevelData, G4GammaTransition
    Gunter Folger fixed use of std::sqrt
- G4Evaporation - improved initialisation (memory leak in QMD model)
- G4ExcitationHandler, G4NeutronRadCapture, G4PhotonEvaporation
    Use recent interface to GetIon()
- G4LevelReader, G4NuclearLevelData, G4DeexPrecoParameters - restored
    possibility to read new data files

24 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-68)
- G4LevelReader - fixed read out of vector boundary

24 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-67)
- G4LevelReader - added protection from the tag hadr-deex-V10-02-58
- G4PhotonEvaporation - fixed crash in test30

23 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-66)
- G4LevelReader, G4NuclearLevelData - rolled back to ref-10
    (hadr-deex-V10-02-53)
- G4PhotonEveporation return back floating level treatment from the
    same tag

22 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-65)
- G4LevelReader - minor reduction of total memory and optimisation
    of reading

21 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-64)
- G4LevelReader - trying to optimise reading

21 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-63)
- G4LevelReader - fixed memory leak; revert method of file reading to
    cand00

18 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-62)
- G4PhotonEvaporation - reduced number of uploaded files
- G4DeexPrecoParameters - extended initialisation printout
- G4LevelReader - an attempt to reduce IO

17 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-61)
- G4PhotonEvaporation - fixed initialisation of time limit for
    meta-stable isomeres
- G4DeexPrecoParameters - added printout of this time limit

16 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-60)
16 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-59)
- G4PhotonEvaporation - fixed sampling of continues gamma emission
- G4NuclearLevelData, G4LevelReader, G4DeexPrecoParameters - added option
    allowing to skip reading levels not used for gamma de-excitation
- G4FermiBreakUpVI, G4FermiFragmentsPoolVI - simplified run time
    applicability check

08 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-58)
- G4LevelReader - added protections for broken data files

05 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-57)
- G4PhotonEvaporation, G4GammaTransition, G4PolarizedGammaTransition
    added sampling of correlated gamma emission

04 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-56)
- G4LevelReader - fixed compillation warning

03 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-55)
- G4FermiFragmentsPoolVI - reduced elim from 30 MeV to 20 MeV
- G4PhotonEvaporation - set verbosity to zero

02 November 2016 Vladimir Ivanchenko (hadr-deex-V10-02-54)
- G4ExcitationHandler, G4DeexPrecoParameters, G4FermiFragmentsPoolVI,
  G4GEMChannelVI, G4LevelManager, G4NucLevel, G4NuclearLevelData,
  G4GammaTransition, G4PolarizedGammaTransition, G4PhotonEvaporation
    - migration to the new structure of gamma level DB, added
      full interface for correlated gamma emission simulation

22 October 2016 Vladimir Ivanchenko (hadr-deex-V10-02-53)
- G4EvaporationProbability, G4KalbachCrossSection - minor performance
    improvement

21 October 2016 Vladimir Ivanchenko (hadr-deex-V10-02-52)
- G4Evaporation, G4EvaporationChannel, G4EvaporationProbability - tuned
    protons/light ions probabilities, more accurate intergration
- G4FermiFragment, G4CoulombBarrier, G4VCoulombBarrier - tuned for
    for evaporation

19 October 2016 Vladimir Ivanchenko (hadr-deex-V10-02-51)
- G4DeexPrecoParameters, G4NuclearLevelData, G4LevelManager,
  G4LevelReader, G4NucLevel - added optional reading of the
    G4LEVELGAMMADATA4.0 extended data which includes full
    information on level and transition angular momentum and parity;
    full description of floating levels; by default old files are
    downloaded; to enable new reading method a flag should be change
    inside G4DeexPrecoParameters
- In number of classes G4Pow pointer identificator is changed from
  g4pow to g4calc

12 October 2016 Vladimir Ivanchenko (hadr-deex-V10-02-50)
- G4EvaporationProbability - fixed non-reproducibility

11 October 2016 Vladimir Ivanchenko (hadr-deex-V10-02-49)
- G4ChatterjeeCrossSection, G4KalbachCrossSection - use Coulomb
    barrier from standard parametersation instead of hard-coded one
    in computation of probability of a fragment emission;
    improved neutron cross section parameterisation below 0.5 MeV
- G4EvaporationChannel, G4EvaporationProbability,
  G4AlphaEvaporationProbability - fixed usage of the Coulomb barrier

05 October 2016 Vladimir Ivanchenko (hadr-deex-V10-02-47)
- G4EvaporationChannel, G4UnstableFragmentBreakUp - sample a decay
    differently if the residual nucleus is n, p, d, t, He3, He4;
    this happens if excitation of an initial fragment is high
- G4UnstableFragmentBreakUp - this class helps to decay exotic states
    which has zero probability to be de-excited via any of normal
    decay; now residual nucleus is check and if it has gamma level
    data the decay chain is continued by normal decays

10 August 2016 Vladimir Ivanchenko (hadr-deex-V10-02-44)
04 August 2016 Vladimir Ivanchenko (hadr-deex-V10-02-43)
- G4ExcitationHandler, G4Evaporation, G4DeexPrecoParameters -
    Improved names and initialisation of set of deexcitation channels

02 August 2016 Vladimir Ivanchenko (hadr-deex-V10-02-42)
- G4GEMChannelVI - new GEM model
- G4EvaporationGEMFactoryVI - usage of the new GEM model

27 July 2016 Vladimir Ivanchenko (hadr-deex-V10-02-41)
- G4VEvaporationChannel, G4Evaporation, G4UnstableFragmentBreakUp
    - implemented improved mechanism of decay of exotic fragments
      by G4Evaporation (exotic means very biased number of protons
      and neutrons)

25 July 2016 Vladimir Ivanchenko (hadr-deex-V10-02-40)
- G4PhotonEvaporationOLD and all associated classes are removed
- G4VEvaporationChannel, G4VEvaporation, G4VFermiBreakUp - removed
    obsolete interfaces , also in derived classes
22 July 2016 Vladimir Ivanchenko (hadr-deex-V10-02-39)
- G4FermiBreakUpVI, G4FermiBreakUp - initialisation of pools
    at construction and deletion in the master thread
22 July 2016 Vladimir Ivanchenko (hadr-deex-V10-02-36)
- G4FermiBreakUpVI, G4FermiChannels, G4FermiDecayProbability,
  G4FermiFragment, G4FermiFragmentsPoolVI - cleanup and tune of
    the new Fermi BreakUp model
- G4ExcitationHandler, G4Evaporation - enable new model by default

18 July 2016 Vladimir Ivanchenko (hadr-deex-V10-02-35)
17 July 2016 Vladimir Ivanchenko (hadr-deex-V10-02-32)
- G4FermiBreakUpVI, G4FermiFragmentsPoolVI, G4FermiPair, G4FermiFragment,
  G4FermiDecayProbability, G4FermiChannels  - added new classes for the
  new Fermi BreakUp model fully based on nuclear level structure DB,
  this new mode is not yet used in any physics list

30 June 2016 Makoto Asai (hadr-deex-V10-02-31)
- Protect G4DeexPrecoParameters::Dump() to print the parapeters only
  in the master thread.

16 June 2016 Vladimir Ivanchenko (hadr-deex-V10-02-30)
- G4PhotonEvaporation - removed debug cout

09 June 2016 Vladimir Ivanchenko (hadr-deex-V10-02-29)
- G4DeexPrecoParameters, G4NuclearLevelData, G4ExcitationHandler,
  G4PhotonEvaporation - fixed initialisation in MT mode if PhysicsList
  has only radioactive decay

09 June 2016 Vladimir Ivanchenko (hadr-deex-V10-02-28)
- G4PhotonEvaporation - fix initialisation, in the case of the
    radioactive decay initialisation was incomplete, no effect on
    hadron inelastic

24 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-27)
- Fixed compillation problems of the previous tag
- Removed specific GEMCoulombBarrier classes per ion

23 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-26)
- G4ExcitationHandler - removed G4Exception when MF model is called,
    instead increase default limit on excitation energy per nucleon
    to 100GeV
- Clean-up CoulombBarrier classes
- Clean-up FermiFragment classes

17 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-25)
- G4ExcitationHandler - fixed crash at destruction introduced in the
    previous tag

17 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-24)
- G4ExcitationHandler - allowing addition of new evaporation or
    FermiBreakUp models after the initialisation of the handler
- G4Evaporation - allowing change of the channel factory after
    initialisation

13 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-23)
- G4KalbachCrossSection - more smooth inverse cross section for
    transitions of high enegry
- G4EvaporationProbability - use the same sampling algorithm as
    in the pre-compound model (do not interpolate probability)

07 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-22)
06 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-21)
- G4DeexPrecoParameters, Evaporation - use default channel factory
- G4NuclearLevelData, G4LevelManager - added method to access low-edge
    levels
- G4EvaporationProbability - more detailed grid for probabilities
- G4NeutronRadCapture - added initialisation of G4PhotonEvaporation

02 May 2016 Vladimir Ivanchenko (hadr-deex-V10-02-20)
- G4DeexPrecoParameters - fixed Coverity warning
- G4VEvaporation, G4Evaporation, G4VFermiBreakUp, G4FermiBreakUp,
  G4PhotonEvaporation, G4ExcitationHandler - cleanup initialisation,
    added G4VFermiBreakUp pure virtual methods allowing to have
    alternative models

27 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-17)
- code cleanup - many minor changes

19 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-16)
- G4EvaporationChannel - fixed division by zero due to previous tags

19 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-15)
- G4ExcitationHandler - fix previous tag for model level tests

19 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-14)
- G4ExcitationHandler, G4DeexPrecoParameters, G4NeutronRadCapture -
    full migration to G4DeexPrecoParameters

15 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-13)
- G4DeexPrecoParameters - added de-excitation parameters;
    allow to change parameters only from the master thread
    and only at PreInit or Idle states
- G4LevelReader, G4VEvaporationChannel, G4LevelReader,
  G4ExcitationHandler - removed commented lines, removed empty
     descructors

11 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-12)
- G4DeexPrecoParameters - added full list of pre-coumpound
    parameters and extra de-excitation parameters
- in many headers added c++11 keywords

08 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-11)
07 Apr 2016 Vladimir Ivanchenko (hadr-deex-V10-02-10)
----------------------------------------------------------
- G4DeexPrecoParameters - renamed G4DeexParameters class and updated
    list of parameters
- G4ExcitationHandler, G4EvaporationChannel, G4EvaporationProbability
    use G4DeexPrecoParameters for initialisation; initialisation
    is done ones at the first event
- G4NucLevel, G4LevelManager, G4LevelReader, G4PhotonEvaporation -
    changed data structure for the transition data: instead of final
    energy, index of final level, added multipolarity of the transition.
    This will allow corellated gamma emission
- G4EvaporationChannel, G4EvaporationProbability - improved
    initialisation of run time members
- G4NuclearLevelData - improved FindLevel method

30 Mar 2016 Vladimir Ivanchenko (hadr-deex-V10-02-09)
----------------------------------------------------------
- G4NuclearLevelData - added method FindLevel allowing to find discrete
    level for any consumer model
- G4EvaporationProbability - fixed bug in computation of probability
    density function; use this new method FindLevel when sample kinetic
    energy of emitted particles; change interface for sampling method
- G4EvaporationChannel - used changed interface to the sampling of energy

22 Mar 2016 Vladimir Ivanchenko (hadr-deex-V10-02-08)
----------------------------------------------------------
- G4ExcitationHandler - improved warning printout for the high
    energy excitation
- G4EvaporationChannel, G4EvaporationProbability - fixed kinematics
    and added discrete excitation energy for the residual fragment
    if the excitation is below max known level energy
- G4DeexParameters, G4NuclearLevelData - added new class for parameters

07 Mar 2016 Vladimir Ivanchenko (hadr-deex-V10-02-07)
----------------------------------------------------------
- G4LevelManager, G4NucLevel - asserts are substituted by G4Exception
- G4NuclearLevelData - extra methods are added allowing to acess the
    max level energy per isotope in level DB
- G4ExcitationHandler - added warning for super excited fragments

01 Mar 2016 Vladimir Ivanchenko (hadr-deex-V10-02-06)
----------------------------------------------------------
- G4PhotonEvaporation - fixed final energy in the case of X-level
- G4ExcitationHandler - subsituted usage of iterators by simple
    loop; add exception for the case of infinite loop of
    evaporation
  Both fixes address the problem report #1837

12 Feb 2016 Vladimir Ivanchenko (hadr-deex-V10-02-05)
----------------------------------------------------------
- remove debug printout

12 Feb 2016 Vladimir Ivanchenko (hadr-deex-V10-02-04)
----------------------------------------------------------
- G4PhotonEvaporation, G4LevelReader, G4NucLevel - fixed treatment
    of X-levels (meta-stable nuclear levels which have forbidden
    gamma transition but opened beta-transitions); this fix excludes
    creation of very low-energy fake gamma and provides a correct
    nuclear decay sequence

20 Jan 2016 Vladimir Ivanchenko (hadr-deex-V10-02-03)
----------------------------------------------------------
- G4PhotonEvaporation, G4LevelManager - fixed one non-reproducibility
    of the recent tag and also hidden rare old non-reproducibilty case

19 Jan 2016 Vladimir Ivanchenko (hadr-deex-V10-02-02)
----------------------------------------------------------
- G4PhotonEvaporation, G4LevelManager, G4LevelReader, G4NuclearLevelData
    fixed remaining cases of production of excited stated (bug #1806)

29 Dec 2015 Vladimir Ivanchenko (hadr-deex-V10-02-01)
----------------------------------------------------------
- G4GammaTransition - add protection against rare problem in samling
    of internal conversion when transition energy is lower than atomic
    level energy: instead of stop of the cascade set bound level
    energy to zero and produce final e-. This allowing to complete
    radioactive decay cascade (bug #1806)

16 Dec 2015 Vladimir Ivanchenko (hadr-deex-V10-02-00)
----------------------------------------------------------
- G4PhotonEvaporation - set limit on emitted gamma energy 0.1 keV
    (was 10 keV)

20 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-63)
----------------------------------------------------------
- G4NuclearLevelData - protect G4MUTEXLOCK by ifdef statement,
    so the lock is not used in sequential mode

18 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-62)
----------------------------------------------------------
- G4PhotonEvaporation - fixed non-reproducibility from previous tag

18 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-61)
----------------------------------------------------------
- G4PhotonEvaporation - computation of probability of gamma emission
    does not use level data information (and not require upload files);
    this reduce CPU used by de-excitation module, should not
    affect results

13 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-60)
----------------------------------------------------------
- G4PhotonEvaporation, G4LevelReader, G4LevelManager - more
    accurate use of G4float, make explicit conversion to G4double
    when needed, use float const for initialisation of float

13 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-59)
----------------------------------------------------------
- G4ExcitationHandler - increase limit for MultiFragmentation
    model from 4 to 400 GeV, so rare cases when a fragment with
    very high excitation is sent to the de-excitation module do
    not treated with this model

12 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-58)
----------------------------------------------------------
- G4PhotonEvaporation - fixed relatively rare non-reproducibility
    in due to problem in sampling of continues transitions

11 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-57)
----------------------------------------------------------
- G4GammaTransition, G4PolarizedGammaTransition added protection
    against wrong shell index

10 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-56)
----------------------------------------------------------
- G4PhotonEvaporation, G4GammaTransition, G4PolarizedGammaTransition
    added protection against fragments with Z > 100

06 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-55)
----------------------------------------------------------
- G4PhotonEvaporation - added prototype of gamma transition
    class with correlated gamma emission

05 Nov 2015 Gabriele Cosmo (hadr-deex-V10-01-54)
----------------------------------------------------------
- Replaced use of variable 'L' in G4LevelReader.cc and
  G4PolarizationTransition to avoid shadowing of new volumetric units.

05 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-53)
----------------------------------------------------------
- G4LevelReader, G4PhotonEvaporation, G4GammaTransition - fixed
    level probabilities

04 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-52)
----------------------------------------------------------
- G4NuclearLevelData, G4LevelReader, G4LevelManager, G4NucLevel -
    fixed non-reproducibility and several other problems in these classes

03 Nov 2015 Vladimir Ivanchenko (hadr-deex-V10-01-51)
----------------------------------------------------------
- G4NuclearLevelData, G4LevelReader - cleanup reading of the data;
    implement lazy initialisation per isotope (before data for all
    isotopes for a given Z were uploaded); this should reduce
    run time memory

27 Oct 2015 Vladimir Ivanchenko (hadr-deex-V10-01-50)
----------------------------------------------------------
- G4LevelManager, G4PhotonEvaporation - fix non-reproducibility

22 Oct 2015 Vladimir Ivanchenko (hadr-deex-V10-01-44)
----------------------------------------------------------
- G4PhotonEvaporation is renamed to G4PhotonEvaporationOLD,
  G4PromptPhotonEvaporation renamed to G4PhotonEvaporation
- G4PromptPhotonEvaporation - fixed gamma emission probability
- G4Evaporation - enable G4PromptPhotonEvaporation by default
- G4PolarizationTransition - removed all static class members and method
    making the code thread safe

18 Oct 2015 Vladimir Ivanchenko (hadr-deex-V10-01-43)
----------------------------------------------------------
- G4PolarizationTransition - new class for correlated gamma emission
    provided by Jason Detwiler
- G4WilsonAblationModel - fixed Coverity report
- G4VEvaporationChannel, G4VEvaporationChannel, G4LevelManager -
    provide extra method GetMaxLevelEnergy() needed for decay channels
    to distingwish continues and discrete excitation states
- G4PromptPhotonEvaporation - code cleanup

02 Sept 2015 Vladimir Ivanchenko (hadr-deex-V10-01-42)
----------------------------------------------------------
- G4NeutronRadCapture, G4Evaporation - use old G4PhotonEvaporation
    by default

01 Sept 2015 Vladimir Ivanchenko (hadr-deex-V10-01-41)
----------------------------------------------------------
- G4NuclearLevelData - fixed lazy initialisation in MT mode

01 Sept 2015 Vladimir Ivanchenko (hadr-deex-V10-01-40)
----------------------------------------------------------
- G4VEvaporationChannel, G4LevelManager, G4EvaporationFactory,
  G4EvaporationDefaultGEMFactory, G4EvaporationGEMFactory - added
    new method GetNearestLevel() providing an access to the nuclear
    level data from any nuclear decay channel
- G4PromptPhotonEvaporation - providing an implementation of
    GetNearestLevel(), several fixes on top of previous tags

31 Aug 2015 Vladimir Ivanchenko (hadr-deex-V10-01-39)
----------------------------------------------------------
- G4WilsonAblationModel, G4NeutronRadCapture - complete migration
    to G4PromptPhotonEvaporation

31 Aug 2015 Vladimir Ivanchenko (hadr-deex-V10-01-38)
----------------------------------------------------------
- G4Evaporation - use G4PromptPhotonEvaporation by default, old
    G4PhotonEvaporation class is enabled via the environment
    variable G4UsePhotonEvaporation
- G4NuclearLevelData - removed debug cout

19 Aug 2015 Vladimir Ivanchenko (hadr-deex-V10-01-37)
----------------------------------------------------------
- G4EvaporationProbability, G4StatMFChannel, G4StatMFMicroPartition
    added header Randomize.hh

17 Aug 2015 Vladimir Ivanchenko (hadr-deex-V10-01-36)
----------------------------------------------------------
- G4Evaporation - access random engine before the loop
- G4FermiPhaseSpaceDecay - removed obsolete method to sample N-body
  decay and left only Kopylov one
- G4PromptPhotonEvaporation - add extra methods to compute probability
  and to sample final states for continium gamma emission

13 Aug 2015 Gabriele Cosmo (hadr-deex-V10-01-35)
----------------------------------------------------------
- Fixed compilation on Windows; added inclusion of <functional>
  to G4FermiPhaseSpaceDecay.cc for definition of std::bind2nd().

07 Aug 2015 Vladimir Ivanchenko (hadr-deex-V10-01-34)
----------------------------------------------------------
- G4VGammaDeexcitation, G4PhotonEvaporation, G4E1Probability,
  G4DiscreteGammaTransition, G4DiscreteGammaDeexcitation,
  G4ContinuumGammaTransition, G4ContinuumGammaDeexcitation
    in all classes tolerance is reduced to 0.1 keV (was from
    1 to 10 keV), this is needed to fix problem #1760

06 Aug 2015 Vladimir Ivanchenko (hadr-deex-V10-01-33)
----------------------------------------------------------
- Fixed compillation

06 Aug 2015 Vladimir Ivanchenko (hadr-deex-V10-01-32)
----------------------------------------------------------
- Technical modeifications: finelized migration to G4Log, G4Exp, G4Pow;
    check do/while loops; code cleanup; fixed Coverity warning

06 Aug 2015 Alberto Ribon       (hadr-deex-V10-01-31)
----------------------------------------------------------
- G4WilsonAblationModel : replaced std::exp and std::pow with the
  faster G4Exp and G4Pow.

22 May 2015 Vladimir Ivanchenko (hadr-deex-V10-01-30)
----------------------------------------------------------
- G4EvaporationChannel, G4EvaporationProbability - optimisation of
    sampling of final state

23 Apr 2015 Vladimir Ivanchenko (hadr-deex-V10-01-29)
----------------------------------------------------------
- G4ChatterjeeCrossSection, G4KalbachCrossSection - J.M. Quesada
    verified/fixed cross sections parameterisations and add comments

16 Apr 2015 Vladimir Ivanchenko (hadr-deex-V10-01-28)
----------------------------------------------------------
- G4NeutronRadCapture - proper initialisation of G4LorentzVector
    in class constructor

16 Apr 2015 Vladimir Ivanchenko (hadr-deex-V10-01-27)
----------------------------------------------------------
- G4FissionParameters, G4CompetitiveFission - fixed kinematics; cleanup

14 Apr 2015 Vladimir Ivanchenko (hadr-deex-V10-01-26)
----------------------------------------------------------
- G4ChatterjeeCrossSection, G4KalbachCrossSection - new cross section
    classes used for all evaporation fragments
- G4AlphaEvaporationProbability, G4DeuteronEvaporationProbability,
  G4EvaporationProbability, G4He3EvaporationProbability,
  G4NeutronEvaporationProbability, G4ProtonEvaporationProbability,
  G4TritonEvaporationProbability - use these new classes, reduced
    number of virtual calls, reduce number of computation in the loop
    of integration

10 Apr 2015 Vladimir Ivanchenko (hadr-deex-V10-01-25)
----------------------------------------------------------
- G4NeutronRadCapture, G4WilsonAblationModel - fixed Coverity reports

27 Mar 2015 Gabriele Cosmo (hadr-deex-V10-01-24)
----------------------------------------------------------
- Corrected GNUmakefile in handler module.

26 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-23)
----------------------------------------------------------
26 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-22)
----------------------------------------------------------
- G4NeutronRadCapture - changed back usage of photon evaporation
    instead of G4Excitation handler; implemented choice
    between G4PhotonEvaporation and G4PromptPhotonEvaporation;
    cleanup the code

21 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-21)
----------------------------------------------------------
- G4VEvaporationChannel, G4PhotonEvaporation - removed "timeType"
    which is not used anymore; removed name of channel
- G4PromptPhotonEvaporation - moved virtual methods to source

16 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-20)
----------------------------------------------------------
- G4WilsonAblationModel, G4EvaporationFactory, G4EvaporationFactory,
  G4ExcitationHandler - use default constructor of G4Evaporation
    and access photon evaporation class from G4Evaporation
- G4Evaporation - use environment variable "G4UsePromptPhotonEvaporation"
    to select gamma de-excitation model; if the variable is defined
    the new G4PromptPhotonEvaporation class is used, in not - the
    old G4PhotonEvaporation

13 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-19)
----------------------------------------------------------
- G4NeutronRadCapture - fixed typo

13 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-18)
----------------------------------------------------------
- G4NeutronRadCapture - restore special treatment of nuclear
    capture in hydrogen (do not use G4ExcitationHandler in that case)
    to avoid rare unrecovable kinematic problem; added check on
    initial kinematics for all isotopes

12 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-17)
----------------------------------------------------------
- G4NeutronRadCapture - fixed kinematics (bug was introduced in the
    previous tag)

11 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-16)
----------------------------------------------------------
- G4NeutronRadCapture - moved to handler sub-directory; use
    G4ExcitationHandler instead of G4PhotonEvaporation allowing
    to have not only gamma de-excitation but fission or FermiBreakUp;
- G4VEvaporationChannel, G4VEvaporation, G4VEvaporationChannel - moved
    Set methods from G4PhotonEvaporation allowing to reduce number of
    new/delete at initialisation
- removed unused dependences from sources.cmake

06 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-15)
----------------------------------------------------------
- disable  G4PromptPhotonEvaporation due to complicate bug in MT mode

06 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-14)
----------------------------------------------------------
- G4LevelManager - fixed wrong assert

06 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-13)
----------------------------------------------------------
- G4NeutronRadCapture, G4ExcitationHandler - use G4PromptPhotonEvaporation

05 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-12)
----------------------------------------------------------
- G4PromptPhotonEvaporation - attempt to fix clang build problem

05 Mar 2015 Vladimir Ivanchenko (hadr-deex-V10-01-11)
----------------------------------------------------------
- G4PromptPhotonEvaporation, G4LevelReader, G4NucLevel - cleanup

27 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-10)
----------------------------------------------------------
- new nuclear data structure classes are moved to management
    sub-directory; fixed Coverity warnings;
- removed obsolete G4E1SingleProbability1, G4VPhotonEvaporation

18 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-09)
18 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-08)
----------------------------------------------------------
- G4LevelReader - correctly defined max G4float value to avoid
    numerical problems

17 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-07)
----------------------------------------------------------
- cleanup all GNUmakefile and source.cmake removing unused
    granula dependencies
- G4LevelReader - add factor to transform half life time into life time

16 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-06)
----------------------------------------------------------
- G4NuclearLevelStore - take out access to G4LavelManager
- G4NuclearLevelData - new data class for nuclear levels and
    gamma transitions; it is pure singleton with data shared
    between threads
- G4LevelReader, G4LevelManager, G4NucLevel - implemented
    data nuclear level management using  G4NuclearLevelData
    class
- removed dependency on hadronic/processes sub-library

13 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-05)
----------------------------------------------------------
- G4GEMProbability - revert to -03 tag

12 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-04)
----------------------------------------------------------
- G4GEMProbability - make protection to be more strong - setup
                     upper limit for excitation of a fragment 8*A*MeV

02 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-03)
----------------------------------------------------------
- G4GEMProbability - due to change of history a very rare bug appeares
    in FTF_BIC Physics List where a nucleus get excited to 8 GeV;
    protection is added to avoid numerical problem

02 Feb 2015 Vladimir Ivanchenko (hadr-deex-V10-01-02)
----------------------------------------------------------
- G4VGammaDeexcitation, G4DiscreteGammaDeexcitation, G4PhotonEvaporation,
    changed default set of parameters: ICM disabled;
    time limit for isomere production is set to DBL_MAX; sampling of
    gamma decay of long-lived isomere levels is performed as it was in
    Geant4 9.6 assuming decay at rest and making correction for energy
    balance (in that case momentum balance is not guranteed); binding
    energy is taken into account in the case of ICM enabled. These
    modifications should provide correct sampling of the decay time for
    all type of levels, energy balance in hadronic interactions, and
    reproducibility of hadronic transport
- G4NeutronRadCapture - enable ICM by default

06 Jan 2015 Laurent Desorgher (hadr-deex-V10-01-01)
----------------------------------------------------------
- G4VGammaDeexcitation::GenerateGamma() take into account atomic bond energy
  for computation of transition energy and kinematics in the case of internal
  conversion.

10 Dec 2014 Vladimir Ivanchenko (hadr-deex-V10-01-00)
----------------------------------------------------------
- G4DiscreteGammaTransition return back correction on shell number
     to avoid assert fail in simplified calorimeter
- G4ContinuumGammaDeexcitation - fixed Coverity report

01 Dec 2014 Vladimir Ivanchenko (hadr-deex-V10-00-29)
----------------------------------------------------------
- G4VGammaDeexcitation, G4PhotonEvaporation - propagate vacant
    shell number after internal conversion allowing to enable
    atomic de-excitation in radioactive decay

28 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-28)
----------------------------------------------------------
- G4FermiBreakUp - fixed value of const coefficient to probability
    of a decay channel

27 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-27)
----------------------------------------------------------
- G4DiscreteGammaDeexcitation, G4DiscreteGammaTransition return
    back checks on transition energy to avoid having very low-energy
    gamma in final state
- G4VGammaDeexcitation - removed not needed extra call to
    CanDoTransition() inside DoChain() method

27 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-26)
----------------------------------------------------------
- G4DiscreteGammaDeexcitation, G4DiscreteGammaTransition fixed
    internal conversion for the case when transition energy is
    nearly electron bound energy

25 Nov 2014 Makoto Asai (hadr-deex-V10-00-25)
----------------------------------------------------------
- G4NuclearLevelManager - remove unnecessary data members to reduce
  the memory consumption.

21 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-24)
----------------------------------------------------------
- G4ContinuumGammaTransition, G4ContinuumGammaDeexcitation,
  G4DiscreteGammaDeexcitation, G4DiscreteGammaTransition,
  G4VGammaDeexcitation - cleanup selection of continues or discrete
    transition
- G4FermiFragmentPool further cleanup values of excitations
- G4ExcitationHandler - added Description for documentation
- GEN probabilities - verified and level energies using gamma
    level data
- G4PhotonEvaporation - improved computation of probability

20 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-23)
----------------------------------------------------------
- G4NuclearLevelStore Makoto Asai redesign the class to enshure that
    the same level is not uploaded twice running in MT mode
- G4FermiFragmentsPool - added DumpFragment() and Dump() methods
- G4VEvaporationChannel, G4GEMChannel, G4GEMProbability - added Dump()
    method
- G4NuclearLevelManager, G4NuclearLevel - added DumpLevels() method
- G4ContinuumGammaTransition, G4VGammaDeexcitation - coherently use
    the same energy tolarence 2 keV

17 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-22)
----------------------------------------------------------
- G4ContinuumGammaTransition - removed normC factor which has no effect
    (return to 10.0 algorithm)
- G4FermiFragmentPool - fixed memory leak at destruction; fixed energy
    or several excited levels to be the same in the gamma level database
- G4E1Probability - removed factor 3 in photon emission probability
- G4B10GEMProbability, G4B11GEMProbability nuclear level energies are
    changed to be the same as in the gamma level database

12 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-21)
----------------------------------------------------------
- G4ContinuumGammaTransition - added factor 3 to probability of
    gamma de-excitation according to theoretical prescriptions
- G4NuclearLevelStore - fixed bug #1684 - wrong deletion of user data
    at exit

07 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-20)
----------------------------------------------------------
- removed debug cout

07 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-19)
----------------------------------------------------------
- removed obsolete G4FermiConfigurationList
- G4ContinuumGammaTransition, G4E1Probability - fixed probability
    computation (J.M.Quesada)

03 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-18)
----------------------------------------------------------
- Fixed build problem

03 Nov 2014 Vladimir Ivanchenko (hadr-deex-V10-00-17)
----------------------------------------------------------
- Cleanup and redesign of photon evaporation

31 Oct 2014 Vladimir Ivanchenko (hadr-deex-V10-00-16)
----------------------------------------------------------
- Improved design of FermiBreakUp and fix decays of "unstable" Fermi
    fragments

29 Oct 2014 Vladimir Ivanchenko (hadr-deex-V10-00-15)
----------------------------------------------------------
- G4FermiBreakUp, G4FermiFragmentsPool, G4VEvaporation,
  G4ExcitationHandler, G4Evaporation, G4EvaporationChannel, G4GEMChannel,
  G4UnstableFragmentBreakUp, G4VEvaporationChannel
    further reduced memory churn

27 Oct 2014 Vladimir Ivanchenko (hadr-deex-V10-00-14)
----------------------------------------------------------
- G4FermiFragmentsPool - added method IfApplicable() for fast check
    if FermiBreakUp is applicable to a given excited fragment
- G4EvaporationChannel, G4Evaporation, G4GEMChannel, G4GEMProbability,
  G4VEvaporationChannel,  G4ExcitationHandler - optimized code
    reducing number of new/delete of intermediate objects, for that
    slightly modified interface to evaporation channel; cleanup
    logic and implementation

26 Oct 2014 Vladimir Ivanchenko (hadr-deex-V10-00-13)
----------------------------------------------------------
- G4ExcitationHandler - fixed problem in isomere production providing
    energy non-concervation on level of 1 MeV

25 Oct 2014 Vladimir Ivanchenko (hadr-deex-V10-00-12)
----------------------------------------------------------
- G4ExcitationHandler, G4Evaporation, G4PhotonEvaporation - added
    protection against abnormal fragments

25 Oct 2014 Vladimir Ivanchenko (hadr-deex-V10-00-11)
----------------------------------------------------------
- G4FermiFragmentsPool - is made pure static singletone, all methods
    and data const in run time, no decay of exotic states
- G4FermiConfigurationList - reduced memory churn by reusing
    vectors which are members of the class; improved and verified
    computation of probabilities; public methods are const
- G4FermiConfiguration, G4UnstableFermiFragment - removed unused
    members; make all methods be const

22 October 2014 Davide Mancusi (hadr-deex-V10-00-10)
----------------------------------------------------------
- Set af/an parameter for INCL++ to 1.02 for all nuclei.

14 October 2014 Davide Mancusi (hadr-deex-V10-00-09)
----------------------------------------------------------
- Moved theChannels and theChannelFactory to the base class, since they seem to
  be common to all classes derived from G4VEvaporation.
- Some code refactoring.
- Introduce an INCL++-specific fission level-density parameter class.

22 Sept 2014 Vladimir Ivanchenko (hadr-deex-V10-00-08)
----------------------------------------------------------
- G4FermiFragmentsPool - revert back to the tag -06; make this
    class to be G4ThreadLocalSingleton, this fixing data race due to
    lazy initialisation but increase memory per thread; this
    tag does not change physics

09 Sept 2014 Vladimir Ivanchenko (hadr-deex-V10-00-07)
----------------------------------------------------------
- G4FermiFragmentsPool - do not create list of extra decays of abnormal
    fragments to avoid data race in MT mode; make all run time method
    cosnt; move inline methods to source

23 July 2014 Vladimir Ivanchenko (hadr-deex-V10-00-06)
----------------------------------------------------------
- G4NuclearLevelStore - use G4ThreadLocalSingleton pattern
    providing proper deletion of photon evaporation classes
    at the end of run

28 March 2014 Gunter Folger    (hadr-deex-V10-00-05)
----------------------------------------------------
-G4ExcitationHandler: add ModelDescription()

26 March 2014 Gunter Folger    (hadr-deex-V10-00-04)
----------------------------------------------------
- use const G4ParticleDefinition*

25 February 2014 Alberto Ribon (hadr-deex-V10-00-03)
----------------------------------------------------
- CMakeLists.txt - reverting back as before the previous tag.

14 February 2014 Mathieu Karamitros (hadr-deex-V10-00-02)
----------------------------------------------------------
- CMakeLists.txt - reordering of add_subdirectory.

07 February 2014 Vladimir Ivanchenko (hadr-deex-V10-00-01)
----------------------------------------------------------
- G4NuclearLevelManager - trivial fix of Coverity report

24 January 2014 Vladimir Ivanchenko (hadr-deex-V10-00-00)
----------------------------------------------------------
- G4ExcitationHandler - fixed minor memory leak in the case when
    FermiBreakUp has no final states available (hadronprocess
    HyperNews post #1371 by Andreas Mueller)

20 November 2013 Vladimir Ivanchenko (hadr-deex-V09-06-27)
----------------------------------------------------------
- G4LevelReader, G4NuclearLevelManager - partial return back of tag
    24 for ReadDataItem method but with attempt to get compile at
    all platforms

15 November 2013 Vladimir Ivanchenko (hadr-deex-V09-06-26)
----------------------------------------------------------
- G4NuclearLevelManager - fixed trivial Coverity warning
- G4NeutronRadcapture - fixed run time memory leak

28 October 2013 Vladimir Ivanchenko (hadr-deex-V09-06-25)
----------------------------------------------------------
- G4LevelReader, G4NuclearLevelManager - attempt to fix compillation
    problem at Windows VC12

24 October 2013 Vladimir Ivanchenko (hadr-deex-V09-06-24)
----------------------------------------------------------
- G4NeutronRadCapture, G4ExcitationHandler - changed max isomer level
    number to 8 (before was 9) due to limitations of PDG encoding

22 October 2013 Vladimir Ivanchenko (hadr-deex-V09-06-23)
----------------------------------------------------------
- G4NeutronRadCapture - added isomere production according to the updated
    MT interface; added time propagation (correct time for delaied capture)
- G4EvaporationChannel, G4ProtonEvaporationProbability, G4F20GEMProbability,
  G4GEMChannel, G4GEMProbability, G4O17GEMProbability, G4ContinuumGammaTransition,
  G4DiscreteGammaTransition - use G4Log and G4Exp

21 October 2013 Gunter Folger      (hadr-deex-V09-06-22)
----------------------------------------------------------
-  fix trivial compilation issues detected on Visual C++ 18
    from Visual studio 12:
	- fermi_breakup/src/G4FermiFragmentsPool.cc use G4endl to
	   end line
	- photon_evaporation/src/{G4NuclearLevelManager,G4LevelReader}.cc
	   check pointer !=0, and don't try to convert basic_istream to bool.

31 August 2013 Vladimir Ivanchenko (hadr-deex-V09-06-21)
----------------------------------------------------------
31 August 2013 Vladimir Ivanchenko (hadr-deex-V09-06-20)
----------------------------------------------------------
- G4ContinuumGammaTransition - fixed bug in previous tag

31 August 2013 Vladimir Ivanchenko (hadr-deex-V09-06-19)
----------------------------------------------------------
- G4ContinuumGammaTransition - use G4Uniformrand and a simple algorithm
    to sample continues gamma transition instead of G4RandGeneralTmp;
    number of bins for sampling - 100 instead of 200
- G4RandGeneralTmp - deleted

19 June 2013 Vladimir Ivanchenko (hadr-deex-V09-06-18)
----------------------------------------------------------
- G4Evaporation - fixed trivial Coverity report

05 June 2013 Alberto Ribon      (hadr-deex-V09-06-17)
----------------------------------------------------------
- G4CompetitiveFission : removed a wrong use of static which caused
    reproducibility violations.

28 May 2013 Vladimir Ivanchenko (hadr-deex-V09-06-16)
----------------------------------------------------------
- G4Evaporation - return back old algorithm to decay light exotic
    fragments to fix non-reproducibility
- G4ExcitationHandler - improved comments

22 May 2013 Vladimir Ivanchenko (hadr-deex-V09-06-15)
----------------------------------------------------------
- G4PhotonEvaporation - correctly propagate time limit to discrete
    de-excitation

10 May 2013 Vladimir Ivanchenko (hadr-deex-V09-06-14)
----------------------------------------------------------
- G4ExcitationHandler - removed debug printout

08 May 2013 Vladimir Ivanchenko (hadr-deex-V09-06-13)
----------------------------------------------------------
- G4ExcitationHandler - added check if an ion exist in isotope table
- G4Evaporation - added check if ground state residual isotope is in
    the ion table
- G4PhotonEvaporation - change time limit to 1 microsecond to be
    coherent with the Geant4 isomere table

06 May 2013 Vladimir Ivanchenko (hadr-deex-V09-06-12)
----------------------------------------------------------
- G4ExcitationHandler - used new methods from particle cathegory to
    find isomere via level index

24 April 2013 Vladimir Ivanchenko (hadr-deex-V09-06-11)
----------------------------------------------------------
- G4ShellCorrection, G4PairingCorrection - fixed Coverity defects

22 April 2013 Vladimir Ivanchenko (hadr-deex-V09-06-10)
----------------------------------------------------------
- G4ExcitationHandler - (J.M.Quesada) fixed typo in the
    SetMaxAForFermiBreakUp method

22 March 2013 Vladimir Ivanchenko (hadr-deex-V09-06-09)
----------------------------------------------------------
- G4WilsonAblationModel - fixed typo

22 March 2013 Vladimir Ivanchenko (hadr-deex-V09-06-08)
----------------------------------------------------------
- G4Evaporation, G4EvaporationProbability, G4CompetitiveFission,
  G4FissionBarrier, G4GEMProbability, G4StatMFMacroNucleon,
  G4StatMFMacroTetraNucleon, G4StatMFMacroTriNucleon,
  G4ContinuumGammaDeexcitation, G4ContinuumGammaTransition,
  G4E1Probability, G4E1SingleProbability1, G4PairingCorrection,
  G4TritonCoulombBarrier - make "const G4double" -> "static const G4double"
    a little performance improvement is expected, improved readability
- G4WilsonAblationModel - added warning that the model is not well validated

21 March 2013 Vladimir Ivanchenko (hadr-deex-V09-06-07)
----------------------------------------------------------
- G4StatMFParameters, G4FermiFragmentsPool, G4PairingCorrection,
  G4ShellCorrection are now singletons initilized once and shared
    between threads
- G4CameronGilbertPairingCorrections, G4CameronGilbertShellCorrections,
  G4CameronShellPlusPairingCorrections, G4CookPairingCorrections,
  G4CameronTruranHilfPairingCorrections, G4CookShellCorrections,
  G4CameronTruranHilfShellCorrections  become simple classes (not
    singletons anymore), which are keeping static data initialized once
- G4EvaporationLevelDensityParameter, G4FissionBarrier are modified
    accordingly

12 March 2013  Dennis Wright (hadr-deex-V09-06-06)
--------------------------------------------------
- fixed MacOS clang compiler warnings: unused private variables _A, _Z
  removed these from G4DiscreteGammaTransition

8 March 2013 Vladimir Ivanchenko (hadr-deex-V09-06-05)
----------------------------------------------------------
- G4UnstableFragmentBreakUp - fixed initialisation

1 March 2013 Andrea Dotti (hadr-deex-V09-06-04)
----------------------------------------------------------
- G4RandGeneralTmp.hh - prepared modification for G4MT.
  No effect (#ifdef protection) for sequential build.
- G4ExcitationHandler - cleaned up logic to create an excited isomer

14 February 2013 Vladimir Ivanchenko (hadr-deex-V09-06-03)
----------------------------------------------------------
- G4StatMFMicroPartition - fixed compillation at Windows

14 February 2013 Vladimir Ivanchenko (hadr-deex-V09-06-02)
----------------------------------------------------------
- G4UnstableFragmentBreakUp - removed static and G4ThreadLocal
- G4StatMF, G4StatMFMicroCanonical, G4StatMFMicroManager,
  G4StatMFMicroPartition - use integer Z and A
- G4VEvaporationChannel - added virtual method GetLifeTime,
    enumerator G4EvaporationChannelType, which is defined in
    constructor of the class; by default
    G4EvaporationChannelType = fDelayedEmission

12 February 2013 Vladimir Ivanchenko (hadr-deex-V09-06-01)
----------------------------------------------------------
- G4ExcitationHandler - fixed typo in access method name:
    GetPhotonEvaporation instead of wrong SetPhotonEvaporation

24 January 2013 Vladimir Ivanchenko (hadr-deex-V09-06-00)
----------------------------------------------------------
- G4ExcitationHandler - if FermiBreakUp returns unchanged
    fragment then the fragment is decayed by Evaporation instead of
    PhotonEvaporation to avoid production of non-physical isotopes
    like (4H)

21 September 2012 Gabriele Cosmo (hadr-deex-V09-05-11)
------------------------------------------------------
- Explicitly use inclusion of headers for system of units and physical
  constants, in plan to remove implicit inclusion from globals.hh.

11 August 2012 Vladimir Ivanchenko (hadr-deex-V09-05-10)
----------------------------------------------------------
- G4DiscreteGammaTransition - minor cleanup

09 August 2012 Vladimir Ivanchenko (hadr-deex-V09-05-09)
----------------------------------------------------------
- G4DiscreteGammaTransition - fixed algorithm of selection of
    discrete transition (bug #1338) - restore transition
    to the ground state in gamma+C12 reaction

06 July 2012 Vladimir Ivanchenko (hadr-deex-V09-05-08)
----------------------------------------------------------
- Fixed remaining shadowing and Coverity warnings in
  G4WilsonAblationModel, G4NeutronRadCapture, G4StatMFMacroTemperature

12 June 2012 Vladimir Ivanchenko (hadr-deex-V09-05-07)
----------------------------------------------------------
11 June 2012 Vladimir Ivanchenko (hadr-deex-V09-05-06)
----------------------------------------------------------
- Fixed shadowing and Coverity warnings

25 May 2012 Vladimir Ivanchenko (hadr-deex-V09-05-05)
----------------------------------------------------------
- G4PhotonEvaporation - added check of environment variable
    G4AddTimeLimitToPhotonEvaporation, if it is define a time
    limit 1.e10-16, comparison of this limit with nuclear level life time
    allows to identify to sample narrow gamma lines or use relativistic
    kinematics which will result in Doppler broading of nuclear lines,
    this option has a side effect - momentum non-conservation
- G4VGammaDeexcitation - use this threshold, cleanup comments
- G4DiscreteGammaTransition - cleanup comments

07 March 2012 Vladimir Ivanchenko (hadr-deex-V09-05-04)
----------------------------------------------------------
- fixed source.cmake

07 March 2012 Vladimir Ivanchenko (hadr-deex-V09-05-03)
----------------------------------------------------------
- G4PhotonEvaporation, G4CompetitiveFission, G4EvaporationChannel,
  G4UnstableFragmentBreakUp, G4GEMChannel, G4VEvaporationChannel,
  G4Evaporation
    removed Initialise method and use GetEmissionProbability method
    directly - minor performance improvement
- G4PromptPhotonEvaporation, G4LevelManager, G4NucLevel,
    G4LevelReader - new classes
- G4NuclearLevelStore - add method GetLevelManager for the new
    G4PromptPhotonEvaporation model


27 January 2012 Vladimir Ivanchenko (hadr-deex-V09-05-02)
----------------------------------------------------------
- G4Evaporation - cleanup logic of initialisation and setup options;
    always define photon evaporation channel as first; removed
    obsolete constructor
- G4EvaporationFactory, G4EvaporationGEMFactory,
	G4EvaporationDefaultGEMFactory - simplified constructors
- G4ExcitationHandler - do not delete G4VEvaporation if it is set
     via Set method (to avoid double deletion by QMD)

23 January 2012 Vladimir Ivanchenko (hadr-deex-V09-05-01)
----------------------------------------------------------
- G4VEvaporationFactory, G4VEvaporation, G4Evaporation, G4EvaporationGEMFactory,
  G4EvaporationFactory, G4EvaporationDefaultGEMFactory - added pointer of
  the G4VPhotonEvaporation to the constructor and delete it at destruction
- G4ExcitationHandler - propagate G4VPhotonEvaporation pointer to G4Evaporation
  and do not delete is at destruction; this allowing to use the same gamma
  evaporation object inside G4Evaporation class and G4ExcitationHandler;
  added access methods to de-excitation components

06 January 2012 Vladimir Ivanchenko (hadr-deex-V09-05-00)
----------------------------------------------------------
- G4VEvaporationFactory, G4Evaporation, G4EvaporationGEMFactory,
  G4EvaporationFactory, G4EvaporationDefaultGEMFactory - added proper
  destruction of decay channels after run

03 November 2011 Laurent Desorgher (hadr-deex-V09-04-21)
----------------------------------------------------------
- Extend the use of G4PhotoEvaporation to Z>100. Note that for Z>100 at the
  moment the binding energy of the vacant e- shell left after internal conversion
  is set as 0 and the atomic relaxation will not be simulated later on.

17 October 2011 Laurent Desorgher (hadr-deex-V09-04-20)
----------------------------------------------------------
- G4NuclearLevelStore (photo-evaporation):
  add AddUserEvaporationDataFile(G4int Z, G4int A,G4String filename)
  The given data file will be used for the treatment of the photo evaporation
  of the given isotope instead of using the file provided in the photo evaporation
  database.

30 September 2011 Vladimir Ivanchenko (hadr-deex-V09-04-19)
----------------------------------------------------------
- G4StatMFMacroCanonical - fixed compillation warnings introduced
  in previous tag

29 September 2011 Vladimir Ivanchenko (hadr-deex-V09-04-18)
----------------------------------------------------------
- G4ProtonEvaporationProbability - fixed Coverity warning
- G4WilsonAblationModel, G4CompetitiveFission, G4StatMF, G4StatMFChannel,
  G4StatMFFragment, G4StatMFMicroCanonical, G4StatMFMacroCanonical,
  G4PhotonEvaporation - complete migration to integer Z and A

13 July 2011 Vladimir Ivanchenko (hadr-deex-V09-04-17)
----------------------------------------------------------
- G4VMultiFragmentation, G4GEMChannel, G4AlphaEvaporationProbability,
  G4DeuteronEvaporationProbability, G4TritonEvaporationProbability,
  G4He3EvaporationProbability, G4ProtonEvaporationProbability,
  G4NeutronEvaporationProbability - Fixed Coverity warnings
- GNUmakefiles and source.cmake - remove non-used dependences
- G4VEvaporationFactory - cleanup

28 June 2011 Vladimir Ivanchenko (hadr-deex-V09-04-16)
----------------------------------------------------------
- G4Evaporation - added extra protection - do not compute GEM probability
  for teh case Eexc > 3MeV*A, fixed FPE probelem for rare FTFP events

27 June 2011 Vladimir Ivanchenko (hadr-deex-V09-04-15)
----------------------------------------------------------
- G4EvaporationProbability - fixed numerical problem - exp function
  of too big argument

06 June 2011 Vladimir Ivanchenko (hadr-deex-V09-04-14)
----------------------------------------------------------
- G4ExcitationHandler - added protection for small excitation energy into
                        photon evaporation loop
- G4Evaporation - directly send low Z,A fragments to the FermiBreakUp model

06 June 2011 Laurent Desorgher (mma)
-----------------------------------
- PhotonEvaporation2.1 : z93.a237 (Np237) alpha coefficients (column 7)
  corrected from Nudat2

20 May 2011 Vladimir Ivanchenko (hadr-deex-V09-04-13)
----------------------------------------------------------
- G4ExcitationHandler - improved comments
- G4NeutronEvaporationProbability, G4ProtonEvaporationProbability -
  fixed gcc-4.6.0 warnings

11 May 2011 Vladimir Ivanchenko (hadr-deex-V09-04-12)
----------------------------------------------------------
- G4GEMCoulombBarrierHE - fixed link problem introduced in previous tags

8 May 2011 Vladimir Ivanchenko (hadr-deex-V09-04-11)
----------------------------------------------------------
- G4DiscreteGammaTransition - enable old usage of the ICM flag to
                              keep 4-momentum balance

7 May 2011 Vladimir Ivanchenko (hadr-deex-V09-04-10)
----------------------------------------------------------
- G4VGammaDeexcitation - added Get method for the ICM flag, commented
                         out usage of this flag during sampling
- G4DiscreteGammaTransition - enable usage of the ICM flag (if false
                              then energy subtracted but e- is not produced)
- G4FermiFragmentPool (J.M.Quesada) improved printout, fixed energy condition

6 May 2011 Vladimir Ivanchenko (hadr-deex-V09-04-09)
----------------------------------------------------------
- G4FermiConfigurationList - fixed minor memory leak
- G4Evaporation, Photon_evaporation, utils - fixed Coverity warnings
- GEM - fixed Coverity warnings, moved constructor and destructor to
  the head for probability and CoulombBarrier classes, add integer Z and A,
  use G4Pow

26 April 2011 Vladimir Ivanchenko (hadr-deex-V09-04-08)
----------------------------------------------------------
- G4FermiConfigurationList - fixed compillation wartning

23 April 2011 Vladimir Ivanchenko (hadr-deex-V09-04-07)
----------------------------------------------------------
- G4FermiSplitter and G4FermiIntegerPartition are removed
- G4FermiConfiguration is now a simple conteiner
- G4FermiConfigurationList - unused methods are removed
- G4FermiFragmentsPool - removed map and access to map methods
- G4ExcitationHandler - updated logic: first call only to MFM
  model, second - evaporation loop, where FBU is called for light
  fragments, products of FBU are sent to the 3d loop on
  photon evaporation

18 April 2011 Vladimir Ivanchenko (hadr-deex-V09-04-06)
----------------------------------------------------------
- fixed source.cmake

06 April 2011 Vladimir Ivanchenko (hadr-deex-V09-04-05)
----------------------------------------------------------
- General cleanup of the FermiBreakUp model: constructors
    and descructors moved to source; integer Z and A; less
    number of 'new' and 'delete'; use G4Pow

04 April 2011 Vladimir Ivanchenko (hadr-deex-V09-04-04)
----------------------------------------------------------
- G4FermiPhaseSpaceDecay - extended printout when kinematics fail,
    fixed computation of majorant in BetaKopylov method,
    general cleanup

30 March 2011 Vladimir Ivanchenko (hadr-deex-V09-04-03)
----------------------------------------------------------
- G4ExcitationHandler - fixed crash at destruction, removed private
    inline methods

22 March 2011 Vladimir Ivanchenko (hadr-deex-V09-04-02)
----------------------------------------------------------
- G4ExcitationHandler (J.M.Quesada) Products of Fermi BreakUp cannot
  be deexcited via  Fermi BreakUp; general cleanup of the class

23 February 2011 Vladimir Ivanchenko (hadr-deex-V09-04-01)
----------------------------------------------------------
- G4NeutronRadCapture - fixed G4Particle change - kill primary
     particle and save residual nucleus

20 January 2011 Vladimir Ivanchenko (hadr-deex-V09-04-00)
----------------------------------------------------------
- G4ParaFissionModel - fixed initialisation of G4Fragment (A,Z order),
                       use G4NucleiProperties to access mass

23 October 2010 Vladimir Ivanchenko (hadr-deex-V09-03-27)
----------------------------------------------------------
- G4Evaporation, G4EvaporationChannel, G4EvaporationProbability -
  improved computation of minimal and maximal evaporation energy
- G4E1Probability, G4PhotonEvaporation - fixed probability

19 October 2010 Vladimir Ivanchenko (hadr-deex-V09-03-26)
----------------------------------------------------------
- G4ParaFissionModel - use GetA_asInt()

18 October 2010 Vladimir Ivanchenko (hadr-deex-V09-03-25)
----------------------------------------------------------
G4GEMChannel - cleanup: integer Z,A; G4Pow; use the same formulas as in
  G4GEMProbability class

17 October 2010 Vladimir Ivanchenko (hadr-deex-V09-03-24)
----------------------------------------------------------
- photon_evaporation, fission - integer Z and A, constructors
   moved to src, usage of G4Pow, general cleanup
- G4ContiniumGammaTransition - use exponential law for sampling of
                               decay time
- removed unused classes: G4DummyProbability, G4E1ProbabilityXXX,
  G4E1SingleProbabilityXXX, where XXX=001,01,1,10,100 - these classes
  are the same as the one really used but a scale factor for the
  probability is different, scale factor may be applied in the main
  class if needed

17 October 2010 Vladimir Ivanchenko (hadr-deex-V09-03-23)
----------------------------------------------------------
- utils, management, evaporation - integer Z and A, constructors
   moved to src, usage of G4Pow, general cleanup
- G4EvaporationChannel - removed new and delete of probability objects
  at each to the class, use instead local G4EvaporationProbability
  of the channel

29 October 2010 Vladimir Ivanchenko (hadr-deex-V09-03-22)
----------------------------------------------------------
- Fixed problems reported by the Coveruty tool (mainly pedantic
  initialisation); moved constructors and destructors to source

12 October 2010 Dennis Wright (hadr-deex-V09-03-21)
---------------------------------------------------
- add Luciano Pandola's README file explaining the photo-evaporation
  data files

11 October 2010 Vladimir Ivanchenko (hadr-deex-V09-03-20)
----------------------------------------------------------

10 October 2010 Michael Kelsey
------------------------------
- G4NuclearLevelManager:  Replace stream input in Read() with char[] input
  and manual conversion to double; eliminate 142 MB memory churn and CPU.

7 October 2010 Michael Kelsey
-----------------------------
- G4NuclearLevelStore, G4NuclearLevelManager, G4NuclearLevel:  Eliminate
  passing and copying of vectors; fill NuclearLevel directly by Manager.
- G4ContinuumGammaTransition.cc:  Follow G4NuclearLevelManager changes.
- G4DiscreteGammaTransition:  Use const-ref for G4NuclerLevel data member.

9 September 2010 Vladimir Ivanchenko (hadr-deex-V09-03-19)
----------------------------------------------------------
- G4NeutronRadCapture - use G4PhotonEvaporation instead of simplfied
                        one gamma emission method; use integer Z and A

9 June 2010 Vladimir Ivanchenko (hadr-deex-V09-03-18)
----------------------------------------------------------
- G4Evaporation - fixed problem of isotope production for high Z
                  fragments introduced in previous tags

25 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-17)
----------------------------------------------------------
- G4E1Probability - added numerical protection to avoid division by zero

19 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-16)
----------------------------------------------------------
- G4UnstableFragmentBreakUp - fix selection of decay channel by addition of check
                              on residual fragment Z and A (addressed
                              problem reported stt for the tag 03-14)

19 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-15)
----------------------------------------------------------
- G4UnstableFragmentBreakUp - fixed selection of decay channel
- G4E1Probability - code cleanup and optimisation by usage of G4Pow, integer A
                    and introduction of const members
- G4GEMProbability - code cleanup and optimisation by usage of G4Pow and integer Z,A
- G4ExcitationHandler - forced  FermiBreakUp for A < 5
- G4PhotonEvaporation - (F.Lei) added correction of electron state after emission
- G4FermiFragmentsPool - JMQ fixed fragment 111

11 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-14)
----------------------------------------------------------
- G4UnstableFragmentBreakUp - new class to decay exotic fragmnet (like 2n or 2p)
- G4Evaporation - added call to G4UnstableFragmentBreakUp if natural abandances
                  of cold fragment is zero; optimized logic of stopping of
                  evaporation loop
- G4PhotonEvaporation - cleanup new methods EmittedFragment and BreakUpFragment
- G4ExcitationHandler - use BreakUpFragment method for photon deexcitation

10 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-13)
----------------------------------------------------------
- G4VGammaDeexcitation - take into account bounding energy of electron
                         in the case of electron emmision; fixed kinematic
- G4DiscreteGammaTransition - Removed unphysical corretions of gamma energy;
                         fixed default particle as gamma; do not subtract
                         bounding energy in case of electron emmision
- G4ExcitationHandler - allowed emmision e- instead of gamma due to internal conversion


03 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-12)
----------------------------------------------------------
- G4Evaporation - improved condition how to stop deexcitation loop
- G4VGammaDeexcitation - take into account electron mass in the case of
                         electron emmision
- G4PhotonEvaporation - improved printout
- G4ExcitationHandler - disable MFM
- G4StatMFFragment, G4CompetitiveFission, G4EvaporationProbability,
  G4GEMProbability - use correct header files

28 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-11)
----------------------------------------------------------
- G4ExcitationHandler - (JQM+VI) add check on stability of primary;
                                 do evaporation if FermiBreakUp or MFM
                                 cannot deexcite a fragment;
	                         added SetParameters method
- G4Evaporation - rewrite BreakUp method; added Initialise method, where setup
                  all options and not at run time; added InitialiseEvaporation
                  method to setup decay channels; changed order of decay
                  channels - first photon evaporation, second - fision,
                  after all other channels as before
- virtual interfaces - moved constructors and destructors to source files

26 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-10)
----------------------------------------------------------
- G4FermiConfiguration - (JQM) parameter of Coulomb energy Kappa is changed
                          from 1 to 6 according to recommendation of original
                          author of the model A. Botvina
- G4FermiPhaseSpaceDecay - (JQM) improved model of sampling of kinetic energy;
                         - (VI) cleanup the code by using G4Pow; moved constructor
                            and destructor to the source

25 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-09)
----------------------------------------------------------
- G4ExcitationHandler - (JQM+VI) apply FermiBreakUp to fragments with A>1
                        (before was A>4) in order to reduce number of
                        fake gamma produced in order deexcite light
                        fragments; added parameter minExcitation = 1 keV
- G4VEvaporationChannel, G4PhotonEvaporation - added 2 new virtual methods
                        EmittedFragment and BreakUpFragment

23 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-08)
----------------------------------------------------------
- G4VGammaDeexcitation - kinematic of 2-body decay rewritten
- G4DiscreteGammaTransition, G4DiscreteGammaDeexcitation,
  G4ContinuumGammaDeexcitation - set energy tolerance 1 keV;
                                 set destructors to be virtual

21 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-07)
----------------------------------------------------------
- G4FermiFragmentsPool - (JMQ) extended list of stable fragments
- G4DiscreteGammaTransition - (JMQ) make transition depended on Z and A
                                    (before was only Z) and added
                                    energy tolerance
- G4ContinuumGammaDeexcitation - (JQM) more accurate Lorentz computations
- G4VGammaDeexcitation - (JMQ) improved Lorentz computations

20 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-06)
----------------------------------------------------------
- G4GEMProbability - (JQM + VI) fixed numerical problem (division by zero)

16 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-05)
----------------------------------------------------------
- G4ExcitationHandler - enable Multi-Fragmentation model
- G4StatMFMacroTemperature - cleanup logic of solving equation for
           temperature; moved constructors and destructor to source

09 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-04)
----------------------------------------------------------
- G4ProtonEvaporationProbability, G4DeuteronEvaporationProbability,
  G4TritonEvaporationProbability, G4He3EvaporationProbability,
  G4AlphaEvaporationProbability - (JMQ) return back to published
               variant OPT3 (Kalbach) parameterization of inverse
	       cross section

05 March 2010 Vladimir Ivanchenko (hadr-deex-V09-03-03)
----------------------------------------------------------
- G4Evaporation - set as a default variant evaporation combined
                  standard + GEM probabilities

17 February 2009 Vladimir Ivanchenko (hadr-deex-V09-03-02)
----------------------------------------------------------
- G4ExcitationHandler - deactivate Multi-Fragmentation model

05 February 2009 Vladimir Ivanchenko (hadr-deex-V09-03-01)
----------------------------------------------------------
- G4ExcitationHandler - activate FermiBreakUp and Multi-Fragmentation models

18 January 2010  Vladimir Ivanchenko (hadr-deex-V09-03-00)
----------------------------------------------------------
- Move 9.3 version to the head of cvs for following files: G4FissionBarrier.hh,
  G4FissionBarrier.cc, G4VGammaDeexcitation.cc, G4VGammaDeexcitation.hh,

09 December 2009 Gunter Folger  (hadr-deex-V09-02-23)
-----------------------------------------------------
- Include fixes in ablation by Pete Truscott:
   Ablation has been updated, largely to comply with updates in
   G4Evaporation, but also some oddities in the way G4Fragment works
   (or doesn't work!), and to fix a bug in fragment identification
   when evaporation isn't used.

01 December 2009 Gabriele Cosmo (hadr-deex-V09-02-22)
-----------------------------------------------------
- Fixed singletons in utils sub-module to canonical form, to help preventing
  leaks reported by Valgrind (tag hadr-deex-util-V09-02-01).
- Corrected argument to std::pow() in G4FermiConfiguration.cc to fix
  compilation problem on Windows VC7.

27 November 2009 Vladimir Ivanchenko (hadr-deex-V09-02-21)
----------------------------------------------------------
- G4ExcitationHandler - cleanup the logic; reduce number internal vectors;
                        fixed memory leak; should work bit faster

24 November 2009 Vladimir Ivanchenko (hadr-deex-V09-02-20)
----------------------------------------------------------
- G4ExcitationHandler - fixed double deletion only on top of tag 18

23 November 2009 Vladimir Ivanchenko (hadr-deex-V09-02-19)
----------------------------------------------------------
- G4ExcitationHandler - fixed double deletion; cleanup logic of
                        new/delete of intermediate G4Fragments
                        reducing number of coping

22 November 2009 Vladimir Ivanchenko (hadr-deex-V09-02-18)
----------------------------------------------------------
- G4FissionLevelDensityParameter tuning using IAEA benchmark

19 November 2009 Vladimir Ivanchenko (hadr-deex-V09-02-17)
----------------------------------------------------------
- G4ExcitationHandler - fixed memory leak

19 November 2009 Vladimir Ivanchenko (hadr-deex-V09-02-16)
----------------------------------------------------------
-  J.M.Quesada retuning for IAEA spallation data fission parameters
    in G4FissionParameters and G4FissionLevelDensityParameter
-  J.M.Quesada improved implementation of Gamma function computation
    in configuration weight inside G4FermiConfiguration
-  V.Ivanchenko added a G4NeutronRadCapture model (a simple 1 gamma
                emission with 4-momentum balance)
-  V.Ivanchenko return default setup of 9.2 for G4ExcitationHandler

08 October 2009 Vladimir Ivanchenko (hadr-deex-V09-02-15)
----------------------------------------------------------
-  J.M.Quesada fixed old problem in G4GEMChannel - computation of
        Coulomb barrier was not consistent with G4GEMProbability

25 September 2009 Vladimir Ivanchenko (hadr-deex-V09-02-14)
----------------------------------------------------------
-  J.M.Quesada fixed G4GEMProbability and G4GEMChannel to provide
   the same probability as proposed in original papers;
   J.M.Quesada fixed G4ExitationHandler to for the case when FermiBreakUp
   and multi-fragmentation model are activated;
-  V.Ivanchenko added a protection on unphysical initial state in G4GEMChannel

16 September 2009 Vladimir Ivanchenko (hadr-deex-V09-02-13)
----------------------------------------------------------
-  J.M.Quesada updated nearly all classes of GEM sub-package by
   introduction new classes G4GEMCoulombBarrier, G4AlphaGEMCoulombBarrier,
   G4DeuteronGEMCoulombBarrier, G4He3GEMCoulombBarrier,
   G4ProtonGEMCoulombBarrier, G4TritonGEMCoulombBarrier and corresponding
   changings in other classes of the sub-package;
   fixed units inside G4GEMProbability computations

27 July 2009 Vladimir Ivanchenko (hadr-deex-V09-02-12)
---------------------------------------------------------
- G4EvaporationGEMFactory - cleanup
- G4Evaporation - added method SetCombinedCannels to define new evaporation
                  factory G4EvaporationDefaultGEMFactory
- G4EvaporationDefaultGEMFactory - new class proposed by J.M.Quesada in
                    which light mesons probabilities are computed from
                    default classes and other fragments from GEM
- G4FissionLevelDensityParameter, G4FissionParameters - J.M.Quesada tuning
                    to IAEA benchmark data

15 July 2009 Vladimir Ivanchenko (hadr-deex-V09-02-11)
---------------------------------------------------------
- G4GEMProbability - J.M.Quesada fixed units (hbar_Plank -> hbarc)

9 July 2009 Vladimir Ivanchenko (hadr-deex-V09-02-10)
---------------------------------------------------------
- G4FermiFragmentsPool - J.M.Quesada fixed units (keV -> MeV), removed
                         wrong levels, added new levels according
                         to  http://www.nndc.bnl.gov/chart

13 March 2009 Vladimir Ivanchenko (hadr-deex-V09-02-09)
---------------------------------------------------------
- G4CompetitiveFission - fixed 4-momentum balance by using direct Lorentz
                         computations (JMQ);
                       - use G4 units (VI).

12 March 2009 Alexander Howard (hadr-deex-V09-02-08)
----------------------------------------------------
- Added Tatsumi's fixes ( G4GEMProbability.cc and G4GEMChannel.cc ) to GEM
  on top of patch9-02 ("hadr-deex-V09-02-07" and "hadr-deex-util-V09-02-00")

04 March 2009 Gabriele Cosmo
----------------------------
- Fixed leaks in singleton classes in the 'util' module. Corrected wherever
  needed inlining of constructors/destructors for base classes and usage of
  virtual specification. Corresponds to tag "hadr-deex-util-V09-02-00".

15 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-07)
---------------------------------------------------------
- G4EvaporationProbability - hbar_Plank substituted by hbarc (JMQ fix)
- G4FissionProbability - fixed forgotten parenthesis (JMQ fix)

13 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-06)
---------------------------------------------------------
- Jose Manuel Quesada change the shape of probabilities (back to 9.2)
  for d, t, He3, alpha near the Coulomb barrier

12 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-05)
---------------------------------------------------------
- Jose Manuel Quesada change the shape of probabilities
  for d, t, He3, alpha near the Coulomb barrier

11 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-04)
---------------------------------------------------------
- Jose Manuel Quesada set default OPT=3 back for all particles
  and add smearing of Coloumb barriers of d, t, he3, alpha

10 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-03)
---------------------------------------------------------
- Exclude updated G4VGammaDeexcitation

10 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-02)
---------------------------------------------------------
- Jose Manuel Quesada set default OPT=3 for evaporation of protons
  and neutrons and OPT=1 for deuterons, tritons, alpha and He3

10 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-01)
---------------------------------------------------------
- Miguel Cortes added extra protection to G4VGammaDeexcitation

27 January 2009 Vladimir Ivanchenko (hadr-deex-V09-02-00)
--------------------------------------------------------
- Miguel Cortes fix of Lorentz transformation in G4VGammaDeexcitation,
  which provides Doppler broading of gamma lines

09 December 2008 Alexander Howard (hadr-deex-V09-01-25)
----------------------------------------------------
- further increased verbosity in G4Evaporation.cc to try to understand channel
  probability failure in very rare case

08 December 2008 Alexander Howard (hadr-deex-V09-01-24)
----------------------------------------------------
- increased verbosity in G4Evaporation.cc to try to understand channel
  probability failure in very rare case

27 November 2008 Alexander Howard (hadr-deex-V09-01-23)
----------------------------------------------------
- added delete to G4EvaporationChannel.cc to fix memory leak

19 November 2008 Dennis Wright (hadr-deex-V09-01-22)
----------------------------------------------------
- fixed bug #1028 in fission/G4CompetitiveFission::FissionCharge:
  trivial change of A to Af in line 343

19 November 2008 V.Ivanchenko (hadr-deex-V09-01-21)
---------------------------------------------------
- added comments to modifications of MF model

19 November 2008 Alexander Howard (hadr-deex-V09-01-20)
-----------------------------------------------------
- Switched OFF FermiBreakUp by default.

19 November 2008 Alexander Howard (hadr-deex-V09-01-19)
-----------------------------------------------------
- Fix from JMQ for Zirconium (nu remains always positive in
  G4NeutronEvaporationProbability.cc)

18 November 2008 Alexander Howard (hadr-deex-V09-01-18)
-----------------------------------------------------
- Fix in G4GEMChannel.cc according to T. Koi (anA,aZ) -> (AResidual,ZResidual)
  for pairing correction in ExEnergy.

05 November 2008 Gabriele Cosmo (hadr-deex-V09-01-17)
-----------------------------------------------------
- Fix in evaporation/G4DeuteronEvaporationProbability.cc for compilation
  error on Windows-VC++; fixed typo in class scope specification for a
  couple of methods...

05 November 2008 Dennis Wright (hadr-deex-V09-01-16)
----------------------------------------------------
- multifragmentation/G4StatMFChannel.cc: fix gcc 4.3 compiler warnings
  at lines 94 and 226.  (place parentheses around && in ||)

24 October 2008 Dennis Wright (hadr-deex-V09-01-15)
---------------------------------------------------
- replace G4NucleiPropertiesTable::GetBindingEnergy with
  G4NucleiProperties::GetBindingEnergy in G4StatMFMacroTriNucleon,
  G4StatMFMacroBiNucleon, and G4StatMFMacroTetraNucleon

30 September 2008 A.Howard (hadr-deex-V09-01-14)
---------------------------------------------------
Correct tag of the head + trivial fix from JMQ to prevent negative
cross-sections for incident protons on targets with A < Carbon.


19 September 2008 A.Howard (hadr-deex-V09-01-13)
---------------------------------------------------
First inclusion of JMQ's recent changes to evaporation and handler.
Directories touched: evaporation (everywhere), handler (MAC's changes + JMQ
interface changes), management (G4VEvaporationChannel.hh (interface)), util
(G4VEmissionProbability.hh (interface)) - MIS-TAGGED - this is closer to ref07
***********PLEASE IGNORE**********


25 July 2008 V.Ivanchenko (hadr-deex-V09-01-12)
---------------------------------------------------
Multi-Fragmentation model have been fixed by I.Pshenichnov in collaboration
with Alexander Botvina and Igor Mishustin (FIAS, Frankfurt, INR,
Moscow and Kurchatov Institute, Moscow, pshenich@fias.uni-frankfurt.de)

G4StatMFMacroTemperature - return original algorithm
G4StatMFMacroMultiplicity - additional checks in solver of equation
                            for the chemical potential
G4StatMFMacroCanonical - fixed infinite loop for a fagment with Z=A;
                         fixed memory leak
G4StatMFChannel - fixed semi-infine loop
G4StatMFMacroMultiNucleon - fixed computation of the symmetry energy

24 July 2008 V.Ivanchenko (hadr-deex-V09-01-11)
---------------------------------------------------
G4EvaporationProbability - Coulomb barrier upgraded (J. M. Quesada)

12 July 2008 V.Ivanchenko (hadr-deex-V09-01-10)
---------------------------------------------------
Integraded fixes in G4EvaporationProbabilities and the tag hadr-deex-V09-01-08,
OPT=2 is set (J. M. Quesada)

05 June 2008 A.Howard (hadr-deex-V09-01-09)
---------------------------------------------------

Fixed memory leak in G4ExcitationHandler thanks to Tatsumi Koi.  The fix is on
top of hadr-deex-V09-01-01, but does not include any of the other subsequent
developments.  Required for public beta release.

05 June 2008 J. M. Quesada (hadr-deex-V09-01-08)
---------------------------------------------------

 Bug fixed in OPT=1 (Chatterjee) charged particle cross sections.
Unphysical values at very low emission energies have been corrected (set
to 0).
OPT=1 by default ( OPT=2 in previous tag)


 24 May 2008 A.Howard (hadr-deex-V09-01-07)
---------------------------------------------------

As hadr-deex-V09-01-06 but with photon_evaporation updated to new interface.
Should now be stable (co-works with low energy tag emlowen-V09-01-14, I guess) -
see hadr-deex-V09-01-01.

 24 May 2008 A.Howard (hadr-deex-V09-01-06)
---------------------------------------------------

As hadr-deex-V09-01-05 but with G4ExcitationHandler.cc put back to correct version


 24 May 2008 A.Howard (hadr-deex-V09-01-05)
---------------------------------------------------

Updated to Jose Manuel Quesada's latest version (should be what was intended in
hadr-deex-V09-01-03).  Does not include Fan Lei's interface change. This is,
however, still on the HEAD.

 24 May 2008 A.Howard (hadr-deex-V09-01-04)
---------------------------------------------------

Updated to Jose Manuel Quesada's latest version (should be what was intended in hadr-deex-V09-01-03).  Also includes Fan Lei's change
to the photon_evaporation interface.


 08 May 2008 J. M. Quesada (hadr-deex-V09-01-03)
---------------------------------------------------

 Coulomb barrier has been added again. Standard parameterization is used for it. It acts as an additional component of inverse reaction cross sections, making it cero when emission energy drops below it. Physical reason:  reaction cross sections come from fitting to exp. data at energies normally well above the barrier. The strong competition betwen the different channels makes it very sensible to subtle differences in emission probabilities at low emission energies, when little excitation energy is available.

 01 May 2008 J. M. Quesada (hadr-deex-V09-01-02)
---------------------------------------------------
- First trial with cvs.
New inverse cross sections:
        OPT=1 Chetterjee's parameterization to reaction cross sections from optical potential global fittings.
        OPT=2 as OPT=1 but for protons the Wellisch's parameterization for protons is used  (DEFAULT)
        OPT=3 Kalbach's modifications of Chatterjee's parameterization of cross sections
        OPT=4 as OPT=3 but for protons the Wellisch's parameterization for protons is used

Coulomb barrier has been suppressed as it enters through inverse cross sections. Also methods related to former Dostrovski's cross sections (alpha , beta and C parameters) have been suppressed.


 01 May 2008 Fan Lei (hadr-deex-V09-01-01)
---------------------------------------------------
- photon_evaporation
  G4PhotonEvaporation.cc: Atomic relaxation model is no longer applied following
  internal electron conversion. Instead the vaccant shell index is passed to
  radioactive decay model, where the ARM is applied.

 21 March 2008 Dennis Wright (hadr-deex-V09-01-00)
--------------------------------------------------
- added parentheses to fix gcc-4.3 compiler warnings in
  G4StatMFChannel::CheckFragments and ::PlaceFragments

 15 November 2007 Alex Howard (hadr-deex-V09-00-06)
---------------------------------------------------
- Added Jose Manuel Quesada's modification to util/src/G4CoulombBarrier.cc in
  order to go back to the original Dostrovski's formulation which is described
  in the Physics Reference Manual.  The previous implementation (from Vicente
  Lara) was inconsistent and less to an under-estimate of the Coulomb Barrier.


 15 November 2007 F Lei (hadr-deex-V09-00-05)
---------------------------------------------------
- photon_evaporation
  bug fix #952. Changes to G4VGammaDeexciation.cc:line 279;
			G4NuclearLevelManageer.cc:line 189;
			G4ContinuumGammaDeexcitation.cc:line133.


 01 November 2007 Dennis Wright (hadr-deex-V09-00-04)
-----------------------------------------------------
- suppressed gamma level file warnings in G4NuclearLevelManager.cc
  To turn them on again, set pre-compiler flag
  CPPFLAGS += -DGAMMAFILEWARNING


 01 October 2007 Alex Howard (hadr-deex-V09-00-03)
---------------------------------------------------
- Protected Rj (Q_beta) factor against divide by zeroes - occurs occasionally.
  Following files were altered:
  G4AlphaEvaporationProbability.hh, G4He3EvaporationProbability.hh,
  G4DeuteronEvaporationProbability.hh, G4NeutronEvaporationProbability.hh,
  G4TritonEvaporationProbability.hh, G4ProtonEvaporationProbability.hh


 19 September 2007 Alex Howard (hadr-deex-V09-00-02)
---------------------------------------------------
- Removed atomic mass number from "gamma factor" within
  G4DeuteronEvaporationProbability.cc, G4TritonEvaporationProbability.cc,
  G4He3EvaporationProbability.cc, G4AlphaEvaporationProbability.cc


 23 August 2007 Alex Howard (hadr-deex-V09-00-01)
-----------------------------------------------
- Removed Coulomb Barrier to beta parameter as it's already included in the
  inverse cross-section formula and is introduced in terms of the energy limit
  of the integration.
- Introduced missing Rj factor in the following files (evaporation module):
  G4EvaporationProbability.cc, G4EvaporationProbability.hh,
  G4AlphaEvaporationProbability.hh, G4DeuteronEvaporationProbability.hh,
  G4He3EvaporationProbability.hh, G4NeutronEvaporationProbability.hh,
  G4ProtonEvaporationProbability.hh, G4TritonEvaporationProbability.hh


 28 July 2007 Alex Howard (hadr-deex-V09-00-00)
-----------------------------------------------
- Added Coulomb Barrier to Beta parameter for inverse channel
cross-section. Needs verification.  Required additions and changes to the
following files:
G4EvaporationProbability.hh, G4EvaporationProbability.cc,
G4AlphaEvaporationProbability.hh, G4DeuteronEvaporationProbability.hh,
G4He3EvaporationProbability.hh, G4NeutronEvaporationProbability.hh,
G4ProtonEvaporationProbability.hh, G4TritonEvaporationProbability.hh,
G4AlphaEvaporationProbability.cc, G4DeuteronEvaporationProbability.cc,
G4He3EvaporationProbability.cc, G4NeutronEvaporationProbability.cc,
G4ProtonEvaporationProbability.cc, G4TritonEvaporationProbability.cc


 5 June 2007 Alex Howard (hadr-deex-V08-03-01)
-----------------------------------------------
- Fixed bug in fix "hadr-deex-V08-03-00" - deleted pointers and iterators were
  attempted to be accessed.  Now a final state iterator list is created and
  filled when necessary.


 18 May 2007 Alex Howard (hadr-deex-V08-03-00)
-----------------------------------------------
- Fixed bug in low A,Z false condition in G4DiscreteGammaDeexcitation.cc, now
the condition is (Z<2 || A<3 || Z>98) false (so stops at Cf rather than >100)
and includes helium (previously excluded)
- Fixed bug in pointer to iterator moving before its beginning G4ExcitationHandler.cc

 14 Feb 2007 Alex Howard (hadr-deex-V08-02-02)
-----------------------------------------------
- evaporation
   Added protection to exclude negative probabilities from the
   "competitive channel sum". With fix below this should only happen due to
   a precision error, but is protected nonetheless.

 12 Feb 2007 Alex Howard (hadr-deex-V08-02-01)
-----------------------------------------------
- fission
   Fixed probability to no longer be negative. Is now equivalent to what is
   written in the Physics Reference Manual. Vicente Lara suggested/agreed
   with fix.

 5 Jan 2007 Dennis Wright (hadr-deex-V08-02-00)
-----------------------------------------------
- fission
   Fixed several memory leaks in G4ParaFissionModel

19 Aug 2006 Dennis Wright (hadr-deex-V08-01-00)
-----------------------------------------------
- multifragmentation
   G4VStatMFMacroCluster.hh : removed meaningless const qualifier from
   methods GetInvLevelDensity, GetZARatio and GetSize

- handler
   G4ExcitationHandler.hh : removed meaningless const qualifier from
   mehtods GetMaxZ, GetMaxA and GetMinE

20 Apr 2006 Dennis Wright (hadr-deex-V08-00-03)
-----------------------------------------------
- photon_evaporation
   G4NuclearLevelManager.cc : in method MakeLevels(), restrict the missing
       file warning to Z > 10

08 Apr 2006 Dennis Wright (hadr-deex-V08-00-02)
----------------------------------------------
- photon_evaporation
  G4PhotonEvaporation.cc : in method BreakItUp(), fix memory leak -
       delete entries to armProducts vector.  This is in response to
       bug report 851.

05 Jan 2006 Dennis Wright (hadr-deex-V08-00-01)
----------------------------------------------

- photon_evaporation
   G4NuclearLevelManager.cc : in method MakeLevels(), re-enable the
       warning that no gamma levels file exists. This is in response
       to bug report 814.

- fission
   G4ParaFissionModel.hh : fix compilation errors which do not show up
       because there is no .cc file.  This is in response to bug report
       817.  Note: splitting this class into header and implementation
       files will have to wait for a directory re-organization because
       as it stands now, there are circular dependencies between the
       fission and evaporation directories.

24 Nov 2005 Dennis Wright (hadr-deex-V07-01-00)
----------------------------------------------

- photon_evaporation (tag hadr-deex-photo-V07-01-00 by Aatos Heikkinen)
   <sstream> migration for G4NuclearLevelManager.cc,
                           G4NuclearLevelDataStore.cc,
                           G4DiscreteGammaDeexcitation.cc
   minor update of G4VGammaDeexcitation.cc

- util (tag hadr-deex-util-V07-01-00 by Aatos Heikkinen)
   <sstream> migration for G4CoulombBarrier.cc
                           G4VCoulombBarrier.cc,

- gem_evaporation (tag hadr-deex-gem-V07-01-00 by Aatos Heikkinen)
   <sstream> migration for G4GEMCoulombBarrierHE.cc

- fermi_breakup (tag hadr-deex-fermi-V07-01-00 by Aatos Heikkinen)
   <sstream> migration for G4FermiSplitter.cc



